//
//
//
//
//
//
//
//
//
////////////////////////////////////////////////////////////////////////////////////////////////////

#ifndef BUFFER_H
#define BUFFER_H

#define WIN32_LEAN_AND_MEAN
#include <windows.h>

#include <gl/gl.h>
#include <gl/glu.h>



enum BufferType
{
   UBYTE_BUFFER,
   USHORT_BUFFER,
   FLOAT_BUFFER
};

enum UtilityTexture
{
   LINEAR_TEXTURE,
   CUBIC_TEXTURE,
   SCRAMBLE_TEXTURE,
   FFT_1024_TEXTURE,
   IFFT_1024_TEXTURE,
   FFT_512_TEXTURE,
   IFFT_512_TEXTURE,
   FFT_256_TEXTURE,
   IFFT_256_TEXTURE,
   FFT_128_TEXTURE,
   IFFT_128_TEXTURE,
   FFT_64_TEXTURE,
   IFFT_64_TEXTURE,
   FFT_32_TEXTURE,
   IFFT_32_TEXTURE,
   FFT_16_TEXTURE,
   IFFT_16_TEXTURE,

   MAX_TEXTURE //used to keep the count on the enumeration
};

bool CreateBuffers();
void DestroyBuffers();

int GetBufferWidth();
int GetBufferHeight();

void BindBuffer( BufferType type);
void UnbindBuffer( BufferType type);

bool IsBufferSupported( BufferType type);

void CreateUtilityTextures();
void BindUtilityTexture( UtilityTexture tex);


#endif //BUFFER_H