//
//
//
//
//
//
//
//
//
////////////////////////////////////////////////////////////////////////////////////////////////////

#include <GL/glut.h>
#include <stdio.h>

#include "ATIExtensions.h"

//
// Simple function to loaf a fragment program
//
////////////////////////////////////////////////////////////////////////////////
GLuint loadFragmentProgram( char* fn)
{
   FILE *fp;
   GLubyte *buf;
   int length;
   bool ret = true;
   GLuint rp;

   if (!(fp = fopen(fn,"rb")))
   {
      return false;
   }

   fseek(fp, 0, SEEK_END);
   length = ftell(fp);
   fseek(fp, 0, SEEK_SET);

   buf = new GLubyte[length+1];

   fread( buf, 1, length, fp);
   buf[length] = '\0'; // make it a regular C string so str* functions work

   glGenProgramsARB( 1, &rp);
   glBindProgramARB( GL_FRAGMENT_PROGRAM_ARB, rp);

   glProgramStringARB( GL_FRAGMENT_PROGRAM_ARB, GL_PROGRAM_FORMAT_ASCII_ARB, length, buf);

   if (glGetError() != 0)
   {
      int position;
      printf("%s\n", glGetString(GL_PROGRAM_ERROR_STRING_ARB));
      glGetIntegerv( GL_PROGRAM_ERROR_POSITION_ARB, &position);
      printf(" @%d\n", position);
      ret = false;
   }

   fclose(fp);

   delete []buf;
   return ret ? rp : 0;
}

//
// Simple function to load a vertex program
//
////////////////////////////////////////////////////////////////////////////////
GLuint loadVertexProgram( char* fn)
{
   FILE *fp;
   GLubyte *buf;
   int length;
   bool ret = true;
   GLuint vp;

   if (!(fp = fopen(fn,"rb")))
   {
      return false;
   }

   fseek(fp, 0, SEEK_END);
   length = ftell(fp);
   fseek(fp, 0, SEEK_SET);

   buf = new GLubyte[length+1];

   fread( buf, 1, length, fp);
   buf[length] = '\0'; // make it a regular C string so str* functions work

   glGenProgramsARB( 1, &vp);
   glBindProgramARB( GL_VERTEX_PROGRAM_ARB, vp);

   glProgramStringARB( GL_VERTEX_PROGRAM_ARB, GL_PROGRAM_FORMAT_ASCII_ARB, length, buf);

   if (glGetError() != 0)
   {
      int lineno;
      printf("%s\n", glGetString(GL_PROGRAM_ERROR_STRING_ARB));
      glGetIntegerv( GL_PROGRAM_ERROR_POSITION_ARB, &lineno);
      printf(" @%d\n", lineno);
      ret = false;
   }

   fclose(fp);

   delete []buf;
   return ret ? vp :0;
}