//
//
//
//
//
//
//
//
////////////////////////////////////////////////////////////////////////////////////////////////////

#ifndef ARCBALL_H
#define ARCBALL_H

class ArcBall
{
   public:
      ArcBall();
      ~ArcBall();

      void SetWidth( int width);
      void SetHeight( int height);

      int GetWidth();
      int GetHeight();

      void Update();

      float* GetMatrix();

      void StartMotion( int x, int y, int time);
      void StopMotion( int x, int y, int time);

      void TrackMotion( int x, int y, int time);

      bool Track() {return m_track;};
      bool ContinuousUpdate() {return m_cUpdate;};

   private:

      void Project(int x, int y, float v[3]);

      float m_matrix[16];

      float m_axis[3];
      float m_angle;

      int m_width;
      int m_height;

      int m_lastTime;

      float m_pos[3];

      bool m_track;
      bool m_cUpdate;
      bool m_trackDirty;

};

#endif //ARCBALL_H