#ifndef _ARRAY_H_
#define _ARRAY_H_

#include <stdlib.h>

template <class ARG_TYPE>
class Array {
protected:
	unsigned int capasity;
	unsigned int size;
	ARG_TYPE *list;
public:
	Array(){
		size = capasity = 0;
		list = NULL;
	}

	Array(const unsigned int iCapasity){
		size = 0;
		capasity = iCapasity;
		list = (ARG_TYPE *) malloc(capasity * sizeof(ARG_TYPE));
	}
	
	~Array(){
		free(list);
	}


	ARG_TYPE &operator [] (const unsigned int index) const {
		return list[index];
	}

	unsigned int add(const ARG_TYPE object){
		if (size >= capasity){
			if (capasity) capasity += capasity; else capasity = 32;
			list = (ARG_TYPE *) realloc(list,capasity * sizeof(ARG_TYPE));
		}
		list[size] = object;
		return size++;
	}

	void remove(const unsigned int index){
		if (index < size){
			size--;
			list[index] = list[size];
		}
	}

	void orderedRemove(const unsigned int index){
		if (index < size){
			size--;
			memmove(list + index, list + index + 1, (size - index) * sizeof(ARG_TYPE));
		}
	}

	void clear(){
		size = 0;
	}

	unsigned int getSize() const {
		return size;
	}
};

#endif // _ARRAY_H_
