#ifndef _MODEL_H_
#define _MODEL_H_

#include "Vector.h"
#include "Array.h"
#include <GL/glut.h>
#include "../include/ATIExtensions.h"

struct ModelVertex {
	Vector vertex;
	Vector normal;
};

struct Mesh {
	ModelVertex *vertices;
	unsigned int nVertices;

	float diffuse[4];
};

class Model {
protected:
	Array <Mesh> meshes;

   float min[3];
   float max[3];

	//GLuint vaoBuffer;
public:
	Model();
	~Model();

	bool loadFile(char *fileName, const int x, const int y, const int z, const float scale);

	unsigned int getMeshCount() const { return meshes.getSize(); }
	void setMeshDiffuse(unsigned int mesh, float r, float g, float b, float a = 1.0f){
		meshes[mesh].diffuse[0] = r;
		meshes[mesh].diffuse[1] = g;
		meshes[mesh].diffuse[2] = b;
		meshes[mesh].diffuse[3] = a;
	}

	void draw();
	void drawDepth();

   float diameter();

};

#endif // _MODEL_H_