//
//
//
//
//
//
////////////////////////////////////////////////////////////////////////////////////////////////////

#include <windows.h>

#include "Timer.h"

#define for if(0);else for

//
//
//
//////////////////////////////////////////////////////////////////////
Timer::Timer( int smooth)
{
   __int64 time;
   m_times = new double[smooth];
   m_count = smooth;
   QueryPerformanceCounter((LARGE_INTEGER*)&time);
   m_initial = (double)time;
   QueryPerformanceFrequency( (LARGE_INTEGER*)&time);
   m_resolution = 1.0/(double)time;
   for (int ii=0; ii<smooth; ii++)
   {
      m_times[ii] = m_initial;
   }
   m_current = 0;
}

//
//
//
//////////////////////////////////////////////////////////////////////
Timer::~Timer()
{
   delete []m_times;
}

//
//
//
//////////////////////////////////////////////////////////////////////
void Timer::UpdateTimer()
{
   __int64 time;
   m_current = (m_current+1)%m_count;
   QueryPerformanceCounter( (LARGE_INTEGER*)&time);
   m_times[m_current] = (double)time;
}

//
//
//
//////////////////////////////////////////////////////////////////////
float Timer::GetAvgHz()
{
   double diff;

   diff = m_times[m_current] - m_times[(m_current+1)%m_count];

   return (float)(1.0/(diff*m_resolution/(double)m_count));
}

//
//
//
//////////////////////////////////////////////////////////////////////
float Timer::GetLastHz()
{
   double diff;

   diff = m_times[m_current] - m_times[m_current ? (m_current-1)%m_count : m_count-1];

   return (float)(1.0/(diff*m_resolution));
}

//
//
//
//////////////////////////////////////////////////////////////////////
float Timer::GetAvgTime()
{
   double diff;

   diff = m_times[m_current] - m_times[(m_current+1)%m_count];

   return (float)(diff*m_resolution/(double)m_count);
}

//
//
//
//////////////////////////////////////////////////////////////////////
float Timer::GetLastTime()
{
   double diff;

   diff = m_times[m_current] - m_times[m_current ? (m_current-1)%m_count : m_count-1];

   return (float)(diff*m_resolution);
}

//
//
//
//////////////////////////////////////////////////////////////////////
float Timer::GetElapsedTime()
{
   double diff;

   diff = m_times[m_current] - m_initial;

   return (float)(diff * m_resolution);
}