/*
** Copyright (C) 2002 ATI Technologies Inc.
*/

#ifndef APIENTRY
#ifdef WIN32
#define WIN32_LEAN_AND_MEAN 1
#include <windows.h>
#endif
#endif

#include <stdlib.h>

#include "ATIExtensions.h"

#ifdef GL_ARB_multisample
GLboolean GL_ARB_multisample_Flag = GL_FALSE;
PFNGLSAMPLECOVERAGEARBPROC glSampleCoverageARB = NULL;
#endif

#ifdef GL_ARB_multitexture
GLboolean GL_ARB_multitexture_Flag = GL_FALSE;
PFNGLACTIVETEXTUREARBPROC glActiveTextureARB = NULL;
PFNGLCLIENTACTIVETEXTUREARBPROC glClientActiveTextureARB = NULL;
PFNGLMULTITEXCOORD1DARBPROC glMultiTexCoord1dARB = NULL;
PFNGLMULTITEXCOORD1DVARBPROC glMultiTexCoord1dvARB = NULL;
PFNGLMULTITEXCOORD1FARBPROC glMultiTexCoord1fARB = NULL;
PFNGLMULTITEXCOORD1FVARBPROC glMultiTexCoord1fvARB = NULL;
PFNGLMULTITEXCOORD1IARBPROC glMultiTexCoord1iARB = NULL;
PFNGLMULTITEXCOORD1IVARBPROC glMultiTexCoord1ivARB = NULL;
PFNGLMULTITEXCOORD1SARBPROC glMultiTexCoord1sARB = NULL;
PFNGLMULTITEXCOORD1SVARBPROC glMultiTexCoord1svARB = NULL;
PFNGLMULTITEXCOORD2DARBPROC glMultiTexCoord2dARB = NULL;
PFNGLMULTITEXCOORD2DVARBPROC glMultiTexCoord2dvARB = NULL;
PFNGLMULTITEXCOORD2FARBPROC glMultiTexCoord2fARB = NULL;
PFNGLMULTITEXCOORD2FVARBPROC glMultiTexCoord2fvARB = NULL;
PFNGLMULTITEXCOORD2IARBPROC glMultiTexCoord2iARB = NULL;
PFNGLMULTITEXCOORD2IVARBPROC glMultiTexCoord2ivARB = NULL;
PFNGLMULTITEXCOORD2SARBPROC glMultiTexCoord2sARB = NULL;
PFNGLMULTITEXCOORD2SVARBPROC glMultiTexCoord2svARB = NULL;
PFNGLMULTITEXCOORD3DARBPROC glMultiTexCoord3dARB = NULL;
PFNGLMULTITEXCOORD3DVARBPROC glMultiTexCoord3dvARB = NULL;
PFNGLMULTITEXCOORD3FARBPROC glMultiTexCoord3fARB = NULL;
PFNGLMULTITEXCOORD3FVARBPROC glMultiTexCoord3fvARB = NULL;
PFNGLMULTITEXCOORD3IARBPROC glMultiTexCoord3iARB = NULL;
PFNGLMULTITEXCOORD3IVARBPROC glMultiTexCoord3ivARB = NULL;
PFNGLMULTITEXCOORD3SARBPROC glMultiTexCoord3sARB = NULL;
PFNGLMULTITEXCOORD3SVARBPROC glMultiTexCoord3svARB = NULL;
PFNGLMULTITEXCOORD4DARBPROC glMultiTexCoord4dARB = NULL;
PFNGLMULTITEXCOORD4DVARBPROC glMultiTexCoord4dvARB = NULL;
PFNGLMULTITEXCOORD4FARBPROC glMultiTexCoord4fARB = NULL;
PFNGLMULTITEXCOORD4FVARBPROC glMultiTexCoord4fvARB = NULL;
PFNGLMULTITEXCOORD4IARBPROC glMultiTexCoord4iARB = NULL;
PFNGLMULTITEXCOORD4IVARBPROC glMultiTexCoord4ivARB = NULL;
PFNGLMULTITEXCOORD4SARBPROC glMultiTexCoord4sARB = NULL;
PFNGLMULTITEXCOORD4SVARBPROC glMultiTexCoord4svARB = NULL;
#endif

#ifdef GL_ARB_texture_compression
GLboolean GL_ARB_texture_compression_Flag = GL_FALSE;
PFNGLCOMPRESSEDTEXIMAGE3DARBPROC glCompressedTexImage3DARB = NULL;
PFNGLCOMPRESSEDTEXIMAGE2DARBPROC glCompressedTexImage2DARB = NULL;
PFNGLCOMPRESSEDTEXIMAGE1DARBPROC glCompressedTexImage1DARB = NULL;
PFNGLCOMPRESSEDTEXSUBIMAGE3DARBPROC glCompressedTexSubImage3DARB = NULL;
PFNGLCOMPRESSEDTEXSUBIMAGE2DARBPROC glCompressedTexSubImage2DARB = NULL;
PFNGLCOMPRESSEDTEXSUBIMAGE1DARBPROC glCompressedTexSubImage1DARB = NULL;
PFNGLGETCOMPRESSEDTEXIMAGEARBPROC glGetCompressedTexImageARB = NULL;
#endif

#ifdef GL_ARB_transpose_matrix
GLboolean GL_ARB_transpose_matrix_Flag = GL_FALSE;
PFNGLLOADTRANSPOSEMATRIXFARBPROC glLoadTransposeMatrixfARB = NULL;
PFNGLLOADTRANSPOSEMATRIXDARBPROC glLoadTransposeMatrixdARB = NULL;
PFNGLMULTTRANSPOSEMATRIXFARBPROC glMultTransposeMatrixfARB = NULL;
PFNGLMULTTRANSPOSEMATRIXDARBPROC glMultTransposeMatrixdARB = NULL;

#endif

#ifdef GL_ARB_vertex_blend
GLboolean GL_ARB_vertex_blend_Flag = GL_FALSE;
PFNGLWEIGHTBVARBPROC glWeightbvARB = NULL;
PFNGLWEIGHTSVARBPROC glWeightsvARB = NULL;
PFNGLWEIGHTIVARBPROC glWeightivARB = NULL;
PFNGLWEIGHTFVARBPROC glWeightfvARB = NULL;
PFNGLWEIGHTDVARBPROC glWeightdvARB = NULL;
PFNGLWEIGHTUBVARBPROC glWeightubvARB = NULL;
PFNGLWEIGHTUSVARBPROC glWeightusvARB = NULL;
PFNGLWEIGHTUIVARBPROC glWeightuivARB = NULL;
PFNGLWEIGHTPOINTERARBPROC glWeightPointerARB = NULL;
PFNGLVERTEXBLENDARBPROC glVertexBlendARB = NULL;
#endif

#ifdef GL_ARB_window_pos
GLboolean GL_ARB_window_pos_Flag = GL_FALSE;
PFNGLWINDOWPOS2DARBPROC glWindowPos2dARB = NULL;
PFNGLWINDOWPOS2FARBPROC glWindowPos2fARB = NULL;
PFNGLWINDOWPOS2IARBPROC glWindowPos2iARB = NULL;
PFNGLWINDOWPOS2SARBPROC glWindowPos2sARB = NULL;
PFNGLWINDOWPOS2IVARBPROC glWindowPos2ivARB = NULL;
PFNGLWINDOWPOS2SVARBPROC glWindowPos2svARB = NULL;
PFNGLWINDOWPOS2FVARBPROC glWindowPos2fvARB = NULL;
PFNGLWINDOWPOS2DVARBPROC glWindowPos2dvARB = NULL;
PFNGLWINDOWPOS3IARBPROC glWindowPos3iARB = NULL;
PFNGLWINDOWPOS3SARBPROC glWindowPos3sARB = NULL;
PFNGLWINDOWPOS3FARBPROC glWindowPos3fARB = NULL;
PFNGLWINDOWPOS3DARBPROC glWindowPos3dARB = NULL;
PFNGLWINDOWPOS3IVARBPROC glWindowPos3ivARB = NULL;
PFNGLWINDOWPOS3SVARBPROC glWindowPos3svARB = NULL;
PFNGLWINDOWPOS3FVARBPROC glWindowPos3fvARB = NULL;
PFNGLWINDOWPOS3DVARBPROC glWindowPos3dvARB = NULL;
#endif

#ifdef GL_ARB_vertex_program
GLboolean GL_ARB_vertex_program_Flag = GL_FALSE;
PFNGLVERTEXATTRIB1SARBPROC glVertexAttrib1sARB = NULL;
PFNGLVERTEXATTRIB1FARBPROC glVertexAttrib1fARB = NULL;
PFNGLVERTEXATTRIB1DARBPROC glVertexAttrib1dARB = NULL;
PFNGLVERTEXATTRIB2SARBPROC glVertexAttrib2sARB = NULL;
PFNGLVERTEXATTRIB2FARBPROC glVertexAttrib2fARB = NULL;
PFNGLVERTEXATTRIB2DARBPROC glVertexAttrib2dARB = NULL;
PFNGLVERTEXATTRIB3SARBPROC glVertexAttrib3sARB = NULL;
PFNGLVERTEXATTRIB3FARBPROC glVertexAttrib3fARB = NULL;
PFNGLVERTEXATTRIB3DARBPROC glVertexAttrib3dARB = NULL;
PFNGLVERTEXATTRIB4SARBPROC glVertexAttrib4sARB = NULL;
PFNGLVERTEXATTRIB4FARBPROC glVertexAttrib4fARB = NULL;
PFNGLVERTEXATTRIB4DARBPROC glVertexAttrib4dARB = NULL;
PFNGLVERTEXATTRIB4NUBARBPROC glVertexAttrib4NubARB = NULL;
PFNGLVERTEXATTRIB1SVARBPROC glVertexAttrib1svARB = NULL;
PFNGLVERTEXATTRIB1FVARBPROC glVertexAttrib1fvARB = NULL;
PFNGLVERTEXATTRIB1DVARBPROC glVertexAttrib1dvARB = NULL;
PFNGLVERTEXATTRIB2SVARBPROC glVertexAttrib2svARB = NULL;
PFNGLVERTEXATTRIB2FVARBPROC glVertexAttrib2fvARB = NULL;
PFNGLVERTEXATTRIB2DVARBPROC glVertexAttrib2dvARB = NULL;
PFNGLVERTEXATTRIB3SVARBPROC glVertexAttrib3svARB = NULL;
PFNGLVERTEXATTRIB3FVARBPROC glVertexAttrib3fvARB = NULL;
PFNGLVERTEXATTRIB3DVARBPROC glVertexAttrib3dvARB = NULL;
PFNGLVERTEXATTRIB4SVARBPROC glVertexAttrib4svARB = NULL;
PFNGLVERTEXATTRIB4FVARBPROC glVertexAttrib4fvARB = NULL;
PFNGLVERTEXATTRIB4DVARBPROC glVertexAttrib4dvARB = NULL;
PFNGLVERTEXATTRIB4IVARBPROC glVertexAttrib4ivARB = NULL;
PFNGLVERTEXATTRIB4BVARBPROC glVertexAttrib4bvARB = NULL;
PFNGLVERTEXATTRIB4USVARBPROC glVertexAttrib4usvARB = NULL;
PFNGLVERTEXATTRIB4UBVARBPROC glVertexAttrib4ubvARB = NULL;
PFNGLVERTEXATTRIB4UIVARBPROC glVertexAttrib4uivARB = NULL;
PFNGLVERTEXATTRIB4NBVARBPROC glVertexAttrib4NbvARB = NULL;
PFNGLVERTEXATTRIB4NSVARBPROC glVertexAttrib4NsvARB = NULL;
PFNGLVERTEXATTRIB4NIVARBPROC glVertexAttrib4NivARB = NULL;
PFNGLVERTEXATTRIB4NUBVARBPROC glVertexAttrib4NubvARB = NULL;
PFNGLVERTEXATTRIB4NUSVARBPROC glVertexAttrib4NusvARB = NULL;
PFNGLVERTEXATTRIB4NUIVARBPROC glVertexAttrib4NuivARB = NULL;
PFNGLVERTEXATTRIBPOINTERARBPROC glVertexAttribPointerARB = NULL;
PFNGLENABLEVERTEXATTRIBARRAYARBPROC glEnableVertexAttribArrayARB = NULL;
PFNGLDISABLEVERTEXATTRIBARRAYARBPROC glDisableVertexAttribArrayARB = NULL;
PFNGLPROGRAMSTRINGARBPROC glProgramStringARB = NULL;
PFNGLBINDPROGRAMARBPROC glBindProgramARB = NULL;
PFNGLDELETEPROGRAMSARBPROC glDeleteProgramsARB = NULL;
PFNGLGENPROGRAMSARBPROC glGenProgramsARB = NULL;
PFNGLPROGRAMENVPARAMETER4DARBPROC glProgramEnvParameter4dARB = NULL;
PFNGLPROGRAMENVPARAMETER4DVARBPROC glProgramEnvParameter4dvARB = NULL;
PFNGLPROGRAMENVPARAMETER4FARBPROC glProgramEnvParameter4fARB = NULL;
PFNGLPROGRAMENVPARAMETER4FVARBPROC glProgramEnvParameter4fvARB = NULL;
PFNGLPROGRAMLOCALPARAMETER4DARBPROC glProgramLocalParameter4dARB = NULL;
PFNGLPROGRAMLOCALPARAMETER4DVARBPROC glProgramLocalParameter4dvARB = NULL;
PFNGLPROGRAMLOCALPARAMETER4FARBPROC glProgramLocalParameter4fARB = NULL;
PFNGLPROGRAMLOCALPARAMETER4FVARBPROC glProgramLocalParameter4fvARB = NULL;
PFNGLGETPROGRAMENVPARAMETERDVARBPROC glGetProgramEnvParameterdvARB = NULL;
PFNGLGETPROGRAMENVPARAMETERFVARBPROC glGetProgramEnvParameterfvARB = NULL;
PFNGLGETPROGRAMLOCALPARAMETERDVARBPROC glGetProgramLocalParameterdvARB = NULL;;
PFNGLGETPROGRAMLOCALPARAMETERFVARBPROC glGetProgramLocalParameterfvARB = NULL;;
PFNGLGETPROGRAMIVARBPROC glGetProgramivARB = NULL;;
PFNGLGETPROGRAMSTRINGARBPROC glGetProgramStringARB = NULL;
PFNGLGETVERTEXATTRIBDVARBPROC glGetVertexAttribdvARB = NULL;
PFNGLGETVERTEXATTRIBFVARBPROC glGetVertexAttribfvARB = NULL;
PFNGLGETVERTEXATTRIBIVARBPROC glGetVertexAttribivARB = NULL;
PFNGLGETVERTEXATTRIBPOINTERVARBPROC glGetVertexAttribPointervARB = NULL;
PFNGLISPROGRAMARBPROC glIsProgramARB = NULL;
#endif

#ifdef GL_ARB_fragment_program
GLboolean GL_ARB_fragment_program_Flag = GL_FALSE;
#ifndef GL_ARB_vertex_program
PFNGLPROGRAMSTRINGARBPROC glProgramStringARB = NULL;
PFNGLBINDPROGRAMARBPROC glBindProgramARB = NULL;
PFNGLDELETEPROGRAMSARBPROC glDeleteProgramsARB = NULL;
PFNGLGENPROGRAMSARBPROC glGenProgramsARB = NULL;
PFNGLPROGRAMENVPARAMETER4DARBPROC glProgramEnvParameter4dARB = NULL;
PFNGLPROGRAMENVPARAMETER4DVARBPROC glProgramEnvParameter4dvARB = NULL;
PFNGLPROGRAMENVPARAMETER4FARBPROC glProgramEnvParameter4fARB = NULL;
PFNGLPROGRAMENVPARAMETER4FVARBPROC glProgramEnvParameter4fvARB = NULL;
PFNGLPROGRAMLOCALPARAMETER4DARBPROC glProgramLocalParameter4dARB = NULL;
PFNGLPROGRAMLOCALPARAMETER4DVARBPROC glProgramLocalParameter4dvARB = NULL;
PFNGLPROGRAMLOCALPARAMETER4FARBPROC glProgramLocalParameter4fARB = NULL;
PFNGLPROGRAMLOCALPARAMETER4FVARBPROC glProgramLocalParameter4fvARB = NULL;
PFNGLGETPROGRAMENVPARAMETERDVARBPROC glGetProgramEnvParameterdvARB = NULL;
PFNGLGETPROGRAMENVPARAMETERFVARBPROC glGetssProgramEnvParameterfvARB = NULL;
PFNGLGETPROGRAMLOCALPARAMETERDVARBPROC glGetProgramLocalParameterdvARB = NULL;;
PFNGLGETPROGRAMLOCALPARAMETERFVARBPROC glGetProgramLocalParameterfvARB = NULL;;
PFNGLGETPROGRAMIVARBPROC glGetProgramivARB = NULL;;
PFNGLGETPROGRAMSTRINGARBPROC glGetProgramStringARB = NULL;;
PFNGLISPROGRAMARBPROC glIsProgramARB = NULL;
#endif
#endif

#ifdef GL_ARB_depth_texture
GLboolean GL_ARB_depth_texture_Flag = GL_FALSE;
#endif

#ifdef GL_ARB_shadow
GLboolean GL_ARB_shadow_Flag = GL_FALSE;
#endif

#ifdef GL_ARB_shadow_ambient
GLboolean GL_ARB_shadow_ambient_Flag = GL_FALSE;
#endif

#ifdef GL_ARB_texture_border_clamp
GLboolean GL_ARB_texture_border_clamp_Flag = GL_FALSE;
#endif

#ifdef GL_ARB_texture_mirror_repeat
GLboolean GL_ARB_texture_mirror_repeat_Flag = GL_FALSE;
#endif

#ifdef GL_ARB_texture_cube_map
GLboolean GL_ARB_texture_cube_map_Flag = GL_FALSE;
#endif 

#ifdef GL_ARB_texture_env_add
GLboolean GL_ARB_texture_env_add_Flag = GL_FALSE;
#endif 

#ifdef GL_ARB_texture_env_combine
GLboolean GL_ARB_texture_env_combine_Flag = GL_FALSE;
#endif 

#ifdef GL_ARB_texture_env_crossbar
GLboolean GL_ARB_texture_env_crossbar_Flag = GL_FALSE;
#endif 

#ifdef GL_ARB_texture_env_dot3
GLboolean GL_ARB_texture_env_dot3_Flag = GL_FALSE;
#endif

#ifdef GL_EXT_vertex_array
GLboolean GL_EXT_vertex_array_Flag = GL_FALSE;
PFNGLARRAYELEMENTEXTPROC glArrayElementEXT = NULL;
PFNGLDRAWARRAYSEXTPROC glDrawArraysEXT = NULL;
PFNGLVERTEXPOINTEREXTPROC glVertexPointerEXT = NULL;
PFNGLNORMALPOINTEREXTPROC glNormalPointerEXT = NULL;
PFNGLCOLORPOINTEREXTPROC glColorPointerEXT = NULL;
PFNGLINDEXPOINTEREXTPROC glIndexPointerEXT = NULL;
PFNGLTEXCOORDPOINTEREXTPROC glTexCoordPointerEXT = NULL;
PFNGLEDGEFLAGPOINTEREXTPROC glEdgeFlagPointerEXT = NULL;
PFNGLGETPOINTERVEXTPROC glGetPointervEXT = NULL;
#endif

#ifdef GL_EXT_compiled_vertex_array
GLboolean GL_EXT_compiled_vertex_array_Flag = GL_FALSE;
PFNGLLOCKARRAYSEXTPROC glLockArraysEXT = NULL;
PFNGLUNLOCKARRAYSEXTPROC glUnlockArraysEXT = NULL;
#endif

#ifdef GL_EXT_texture_object
GLboolean GL_EXT_texture_object_Flag = GL_FALSE;
PFNGLGENTEXTURESEXTPROC glGenTexturesEXT = NULL;
PFNGLDELETETEXTURESEXTPROC glDeleteTexturesEXT = NULL;
PFNGLBINDTEXTUREEXTPROC glBindTextureEXT = NULL;
PFNGLPRIORITIZETEXTURESEXTPROC glPrioritizeTexturesEXT = NULL;
PFNGLARETEXTURESRESIDENTEXTPROC glAreTexturesResidentEXT = NULL;
PFNGLISTEXTUREEXTPROC glIsTextureEXT = NULL;
#endif

#ifdef GL_EXT_fog_coord
GLboolean GL_EXT_fog_coord_Flag = GL_FALSE;
PFNGLFOGCOORDFEXTPROC glFogCoordfEXT = NULL;
PFNGLFOGCOORDDEXTPROC glFogCoorddEXT = NULL;
PFNGLFOGCOORDFVEXTPROC glFogCoordfvEXT = NULL;
PFNGLFOGCOORDDVEXTPROC glFogCoorddvEXT = NULL;
PFNGLFOGCOORDPOINTEREXTPROC glFogCoordPointerEXT = NULL;
#endif

#ifdef GL_EXT_secondary_color
GLboolean GL_EXT_secondary_color_Flag = GL_FALSE;
PFNGLSECONDARYCOLOR3FEXTPROC glSecondaryColor3fEXT = NULL;
PFNGLSECONDARYCOLOR3DEXTPROC glSecondaryColor3dEXT = NULL;
PFNGLSECONDARYCOLOR3BEXTPROC glSecondaryColor3bEXT = NULL;
PFNGLSECONDARYCOLOR3SEXTPROC glSecondaryColor3sEXT = NULL;
PFNGLSECONDARYCOLOR3IEXTPROC glSecondaryColor3iEXT = NULL;
PFNGLSECONDARYCOLOR3UBEXTPROC glSecondaryColor3ubEXT = NULL;
PFNGLSECONDARYCOLOR3USEXTPROC glSecondaryColor3usEXT = NULL;
PFNGLSECONDARYCOLOR3UIEXTPROC glSecondaryColor3uiEXT = NULL;
PFNGLSECONDARYCOLOR3FVEXTPROC glSecondaryColor3fvEXT = NULL;
PFNGLSECONDARYCOLOR3DVEXTPROC glSecondaryColor3dvEXT = NULL;
PFNGLSECONDARYCOLOR3BVEXTPROC glSecondaryColor3bvEXT = NULL;
PFNGLSECONDARYCOLOR3SVEXTPROC glSecondaryColor3svEXT = NULL;
PFNGLSECONDARYCOLOR3IVEXTPROC glSecondaryColor3ivEXT = NULL;
PFNGLSECONDARYCOLOR3UBVEXTPROC glSecondaryColor3ubvEXT = NULL;
PFNGLSECONDARYCOLOR3USVEXTPROC glSecondaryColor3usvEXT = NULL;
PFNGLSECONDARYCOLOR3UIVEXTPROC glSecondaryColor3uivEXT = NULL;
PFNGLSECONDARYCOLORPOINTEREXTPROC glSecondaryColorPointerEXT = NULL;
#endif

#ifdef GL_EXT_draw_range_elements
GLboolean GL_EXT_draw_range_elements_Flag = GL_FALSE;
PFNGLDRAWRANGEELEMENTSEXTPROC glDrawRangeElementsEXT = NULL;
#endif

#ifdef GL_EXT_multi_draw_arrays
GLboolean GL_EXT_multi_draw_arrays_Flag = GL_FALSE;
PFNGLMULTIDRAWARRAYSEXTPROC glMultiDrawArraysEXT = NULL;
PFNGLMULTIDRAWELEMENTSEXTPROC glMultiDrawElementsEXT = NULL;
#endif

#ifdef GL_EXT_texture3D
GLboolean GL_EXT_texture3D_Flag = GL_FALSE;
PFNGLTEXIMAGE3DEXTPROC glTexImage3DEXT = NULL;
PFNGLTEXSUBIMAGE3DPROC glTexSubImage3DEXT = NULL;
PFNGLCOPYTEXSUBIMAGE3DPROC glCopyTexSubImage3DEXT = NULL;
#endif

#ifdef GL_EXT_point_parameters
GLboolean GL_EXT_point_parameters_Flag = GL_FALSE;
PFNGLPOINTPARAMETERFEXTPROC glPointParameterfEXT = NULL;
PFNGLPOINTPARAMETERFVEXTPROC glPointParameterfvEXT = NULL;
#endif

#ifdef GL_ARB_point_parameters
GLboolean GL_ARB_point_parameters_Flag = GL_FALSE;
PFNGLPOINTPARAMETERFEXTPROC glPointParameterfARB = NULL;
PFNGLPOINTPARAMETERFVEXTPROC glPointParameterfvARB = NULL;
#endif

#ifdef GL_EXT_vertex_shader
GLboolean GL_EXT_vertex_shader_Flag = GL_FALSE;
PFNGLBEGINVERTEXSHADEREXTPROC glBeginVertexShaderEXT = NULL;
PFNGLENDVERTEXSHADEREXTPROC glEndVertexShaderEXT = NULL;
PFNGLBINDVERTEXSHADEREXTPROC glBindVertexShaderEXT = NULL;
PFNGLGENVERTEXSHADERSEXTPROC glGenVertexShadersEXT = NULL;
PFNGLDELETEVERTEXSHADEREXTPROC glDeleteVertexShaderEXT = NULL;
PFNGLSHADEROP1EXTPROC glShaderOp1EXT = NULL;
PFNGLSHADEROP2EXTPROC glShaderOp2EXT = NULL;
PFNGLSHADEROP3EXTPROC glShaderOp3EXT = NULL;
PFNGLSWIZZLEEXTPROC glSwizzleEXT = NULL;
PFNGLWRITEMASKEXTPROC glWriteMaskEXT = NULL;
PFNGLINSERTCOMPONENTEXTPROC glInsertComponentEXT = NULL;
PFNGLEXTRACTCOMPONENTEXTPROC glExtractComponentEXT = NULL;
PFNGLGENSYMBOLSEXTPROC glGenSymbolsEXT = NULL;
PFNGLSETINVARIANTEXTPROC glSetInvariantEXT = NULL;
PFNGLSETLOCALCONSTANTEXTPROC glSetLocalConstantEXT = NULL;
PFNGLVARIANTBVEXTPROC glVariantbvEXT = NULL;
PFNGLVARIANTSVEXTPROC glVariantsvEXT = NULL;
PFNGLVARIANTIVEXTPROC glVariantivEXT = NULL;
PFNGLVARIANTFVEXTPROC glVariantfvEXT = NULL;
PFNGLVARIANTDVEXTPROC glVariantdvEXT = NULL;
PFNGLVARIANTUBVEXTPROC glVariantubvEXT = NULL;
PFNGLVARIANTUSVEXTPROC glVariantusvEXT = NULL;
PFNGLVARIANTUIVEXTPROC glVariantuivEXT = NULL;
PFNGLVARIANTPOINTEREXTPROC glVariantPointerEXT = NULL;
PFNGLENABLEVARIANTCLIENTSTATEEXTPROC glEnableVariantClientStateEXT = NULL;
PFNGLDISABLEVARIANTCLIENTSTATEEXTPROC glDisableVariantClientStateEXT = NULL;
PFNGLBINDLIGHTPARAMETEREXTPROC glBindLightParameterEXT = NULL;
PFNGLBINDMATERIALPARAMETEREXTPROC glBindMaterialParameterEXT = NULL;
PFNGLBINDTEXGENPARAMETEREXTPROC glBindTexGenParameterEXT = NULL;
PFNGLBINDTEXTUREUNITPARAMETEREXTPROC glBindTextureUnitParameterEXT = NULL;
PFNGLBINDPARAMETEREXTPROC glBindParameterEXT = NULL;
PFNGLISVARIANTENABLEDEXTPROC glIsVariantEnabledEXT = NULL;
PFNGLGETVARIANTBOOLEANVEXTPROC glGetVariantBooleanvEXT = NULL;
PFNGLGETVARIANTINTEGERVEXTPROC glGetVariantIntegervEXT = NULL;
PFNGLGETVARIANTFLOATVEXTPROC glGetVariantFloatvEXT = NULL;
PFNGLGETVARIANTPOINTERVEXTPROC glGetVariantPointervEXT = NULL;
PFNGLGETINVARIANTBOOLEANVEXTPROC glGetInvariantBooleanvEXT = NULL;
PFNGLGETINVARIANTINTEGERVEXTPROC glGetInvariantIntegervEXT = NULL;
PFNGLGETINVARIANTFLOATVEXTPROC glGetInvariantFloatvEXT = NULL;
PFNGLGETLOCALCONSTANTBOOLEANVEXTPROC glGetLocalConstantBooleanvEXT = NULL;
PFNGLGETLOCALCONSTANTINTEGERVEXTPROC glGetLocalConstantIntegervEXT = NULL;
PFNGLGETLOCALCONSTANTFLOATVEXTPROC glGetLocalConstantFloatvEXT = NULL;
#endif

#ifdef GL_EXT_blend_minmax
GLboolean GL_EXT_blend_minmax_Flag = GL_FALSE;
PFNGLBLENDEQUATIONEXTPROC glBlendEquationEXT = NULL;
#endif

#ifdef GL_EXT_blend_func_separate
GLboolean GL_EXT_blend_func_separate_Flag = GL_FALSE;
PFNGLBLENDFUNCSEPARATEEXTPROC glBlendFuncSeparateEXT = NULL;
#endif

#ifdef GL_EXT_blend_color
GLboolean GL_EXT_blend_color_Flag = GL_FALSE;
PFNGLBLENDCOLOREXTPROC glBlendColorEXT = NULL;
#endif

#ifdef GL_EXT_abgr 
GLboolean GL_EXT_abgr_Flag = GL_FALSE;
#endif 

#ifdef GL_EXT_bgra
GLboolean GL_EXT_bgra_Flag = GL_FALSE;
#endif 

#ifdef GL_EXT_blend_subtract
GLboolean GL_EXT_blend_subtract_Flag = GL_FALSE;
#endif

#ifdef GL_EXT_clip_volume_hint
GLboolean GL_EXT_clip_volume_hint_Flag = GL_FALSE;
#endif 

#ifdef GL_EXT_packed_pixels
GLboolean GL_EXT_packed_pixels_Flag = GL_FALSE;
#endif 

#ifdef GL_EXT_rescale_normal
GLboolean GL_EXT_rescale_normal_Flag = GL_FALSE;
#endif

#ifdef GL_EXT_separate_specular_color
GLboolean GL_EXT_separate_specular_color_Flag = GL_FALSE;
#endif 

#ifdef GL_EXT_texgen_reflection
GLboolean GL_EXT_texgen_reflection_Flag = GL_FALSE;
#endif 

#ifdef GL_EXT_texture_cube_map
GLboolean GL_EXT_texture_cube_map_Flag = GL_FALSE;
#endif 

#ifdef GL_EXT_texture_compression_s3tc
GLboolean GL_EXT_texture_compression_s3tc_Flag = GL_FALSE;
#endif

#ifdef GL_EXT_texture_edge_clamp
GLboolean GL_EXT_texture_edge_clamp_Flag = GL_FALSE;
#endif 

#ifdef GL_EXT_texture_env_add
GLboolean GL_EXT_texture_env_add_Flag = GL_FALSE;
#endif

#ifdef GL_EXT_texture_env_combine
GLboolean GL_EXT_texture_env_combine_Flag = GL_FALSE;
#endif 

#ifdef GL_EXT_texture_env_dot3
GLboolean GL_EXT_texture_env_dot3_Flag = GL_FALSE;
#endif 

#ifdef GL_EXT_texture_filter_anisotropic
GLboolean GL_EXT_texture_filter_anisotropic_Flag = GL_FALSE;
#endif 

#ifdef GL_EXT_stencil_wrap
GLboolean GL_EXT_stencil_wrap_Flag = GL_FALSE;
#endif

#ifdef GL_EXT_texture_rectangle
GLboolean GL_EXT_texture_rectangle_Flag = GL_FALSE;
#endif

#ifdef GL_ATI_envmap_bumpmap
GLboolean GL_ATI_envmap_bumpmap_Flag = GL_FALSE;
PFNGLTEXBUMPPARAMETERIVATIPROC glTexBumpParameterivATI = NULL;
PFNGLTEXBUMPPARAMETERFVATIPROC glTexBumpParameterfvATI = NULL;
PFNGLGETTEXBUMPPARAMETERIVATIPROC glGetTexBumpParameterivATI = NULL;
PFNGLGETTEXBUMPPARAMETERFVATIPROC glGetTexBumpParameterfvATI = NULL;
#endif

#ifdef GL_ATI_fragment_shader
GLboolean GL_ATI_fragment_shader_Flag = GL_FALSE;
PFNGLGENFRAGMENTSHADERSATIPROC glGenFragmentShadersATI = NULL;
PFNGLBINDFRAGMENTSHADERATIPROC glBindFragmentShaderATI = NULL;
PFNGLDELETEFRAGMENTSHADERATIPROC glDeleteFragmentShaderATI = NULL;
PFNGLBEGINFRAGMENTSHADERATIPROC glBeginFragmentShaderATI = NULL;
PFNGLENDFRAGMENTSHADERATIPROC glEndFragmentShaderATI = NULL;
PFNGLPASSTEXCOORDATIPROC glPassTexCoordATI = NULL;
PFNGLSAMPLEMAPATIPROC glSampleMapATI = NULL;
PFNGLCOLORFRAGMENTOP1ATIPROC glColorFragmentOp1ATI = NULL;
PFNGLCOLORFRAGMENTOP2ATIPROC glColorFragmentOp2ATI = NULL;
PFNGLCOLORFRAGMENTOP3ATIPROC glColorFragmentOp3ATI = NULL;
PFNGLALPHAFRAGMENTOP1ATIPROC glAlphaFragmentOp1ATI = NULL;
PFNGLALPHAFRAGMENTOP2ATIPROC glAlphaFragmentOp2ATI = NULL;
PFNGLALPHAFRAGMENTOP3ATIPROC glAlphaFragmentOp3ATI = NULL;
PFNGLSETFRAGMENTSHADERCONSTANTATIPROC glSetFragmentShaderConstantATI = NULL;
#endif

#ifdef GL_ATI_vertex_array_object
GLboolean GL_ATI_vertex_array_object_Flag = GL_FALSE;
PFNGLNEWOBJECTBUFFERATIPROC glNewObjectBufferATI = NULL;
PFNGLISOBJECTBUFFERATIPROC glIsObjectBufferATI = NULL;
PFNGLUPDATEOBJECTBUFFERATIPROC glUpdateObjectBufferATI = NULL;
PFNGLGETOBJECTBUFFERFVATIPROC glGetObjectBufferfvATI = NULL;
PFNGLGETOBJECTBUFFERIVATIPROC glGetObjectBufferivATI = NULL;
PFNGLFREEOBJECTBUFFERATIPROC glFreeObjectBufferATI = NULL;
PFNGLARRAYOBJECTATIPROC glArrayObjectATI = NULL;
PFNGLGETARRAYOBJECTFVATIPROC glGetArrayObjectfvATI = NULL;
PFNGLGETARRAYOBJECTIVATIPROC glGetArrayObjectivATI = NULL;
PFNGLVARIANTARRAYOBJECTATIPROC glVariantArrayObjectATI = NULL;
PFNGLGETVARIANTARRAYOBJECTFVATIPROC glGetVariantArrayObjectfvATI = NULL;
PFNGLGETVARIANTARRAYOBJECTIVATIPROC glGetVariantArrayObjectivATI = NULL;
#endif

#ifdef GL_ATI_element_array
GLboolean GL_ATI_element_array_Flag = GL_FALSE;
PFNGLELEMENTPOINTERATIPROC glElementPointerATI = NULL;
PFNGLDRAWELEMENTARRAYATIPROC glDrawElementArrayATI = NULL;
PFNGLDRAWRANGEELEMENTARRAYATIPROC glDrawRangeElementArrayATI = NULL;
#endif

#ifdef GL_ATI_vertex_attrib_array_object
GLboolean GL_ATI_vertex_attrib_array_object_Flag = GL_FALSE;
PFNGLVERTEXATTRIBARRAYOBJECTATIPROC glVertexAttribArrayObjectATI = NULL;
PFNGLGETVERTEXATTRIBARRAYOBJECTFVATIPROC glVertexAttribArrayObjectfvATI = NULL;
PFNGLGETVERTEXATTRIBARRAYOBJECTIVATIPROC glVertexAttribArrayObjectivATI = NULL;
#endif

#ifdef GL_ATI_pn_triangles
GLboolean GL_ATI_pn_triangles_Flag = GL_FALSE;
PFNGLPNTRIANGLESIATIPROC glPNTrianglesiATI = NULL;
PFNGLPNTRIANGLESFATIPROC glPNTrianglesfATI = NULL;
#endif

#ifdef GL_ATI_vertex_streams
GLboolean GL_ATI_vertex_streams_Flag = GL_FALSE;
PFNGLCLIENTACTIVEVERTEXSTREAMATIPROC glClientActiveVertexStreamATI = NULL;
PFNGLVERTEXBLENDENVIATIPROC glVertexBlendEnviATI = NULL;
PFNGLVERTEXBLENDENVFATIPROC glVertexBlendEnvfATI = NULL;
PFNGLVERTEXSTREAM2SATIPROC glVertexStream2sATI = NULL;
PFNGLVERTEXSTREAM2SVATIPROC glVertexStream2svATI = NULL;
PFNGLVERTEXSTREAM2IATIPROC glVertexStream2iATI = NULL;
PFNGLVERTEXSTREAM2IVATIPROC glVertexStream2ivATI = NULL;
PFNGLVERTEXSTREAM2FATIPROC glVertexStream2fATI = NULL;
PFNGLVERTEXSTREAM2FVATIPROC glVertexStream2fvATI = NULL;
PFNGLVERTEXSTREAM2DATIPROC glVertexStream2dATI = NULL;
PFNGLVERTEXSTREAM2DVATIPROC glVertexStream2dvATI = NULL;
PFNGLVERTEXSTREAM3SATIPROC glVertexStream3sATI = NULL;
PFNGLVERTEXSTREAM3SVATIPROC glVertexStream3svATI = NULL;
PFNGLVERTEXSTREAM3IATIPROC glVertexStream3iATI = NULL;
PFNGLVERTEXSTREAM3IVATIPROC glVertexStream3ivATI = NULL;
PFNGLVERTEXSTREAM3FATIPROC glVertexStream3fATI = NULL;
PFNGLVERTEXSTREAM3FVATIPROC glVertexStream3fvATI = NULL;
PFNGLVERTEXSTREAM3DATIPROC glVertexStream3dATI = NULL;
PFNGLVERTEXSTREAM3DVATIPROC glVertexStream3dvATI = NULL;
PFNGLVERTEXSTREAM4SATIPROC glVertexStream4sATI = NULL;
PFNGLVERTEXSTREAM4SVATIPROC glVertexStream4svATI = NULL;
PFNGLVERTEXSTREAM4IATIPROC glVertexStream4iATI = NULL;
PFNGLVERTEXSTREAM4IVATIPROC glVertexStream4ivATI = NULL;
PFNGLVERTEXSTREAM4FATIPROC glVertexStream4fATI = NULL;
PFNGLVERTEXSTREAM4FVATIPROC glVertexStream4fvATI = NULL;
PFNGLVERTEXSTREAM4DATIPROC glVertexStream4dATI = NULL;
PFNGLVERTEXSTREAM4DVATIPROC glVertexStream4dvATI = NULL;
PFNGLNORMALSTREAM3BATIPROC glNormalStream3bATI = NULL;
PFNGLNORMALSTREAM3BVATIPROC glNormalStream3bvATI = NULL;
PFNGLNORMALSTREAM3SATIPROC glNormalStream3sATI = NULL;
PFNGLNORMALSTREAM3SVATIPROC glNormalStream3svATI = NULL;
PFNGLNORMALSTREAM3IATIPROC glNormalStream3iATI = NULL;
PFNGLNORMALSTREAM3IVATIPROC glNormalStream3ivATI = NULL;
PFNGLNORMALSTREAM3FATIPROC glNormalStream3fATI = NULL;
PFNGLNORMALSTREAM3FVATIPROC glNormalStream3fvATI = NULL;
PFNGLNORMALSTREAM3DATIPROC glNormalStream3dATI = NULL;
PFNGLNORMALSTREAM3DVATIPROC glNormalStream3dvATI = NULL;
#endif

#ifdef GL_ATI_separate_stencil
GLboolean GL_ATI_separate_stencil_Flag = GL_FALSE;
PFNGLSTENCILOPSEPARATEATIPROC glStencilOpSeparateATI = NULL;
PFNGLSTENCILFUNCSEPARATEATIPROC glStencilFuncSeparateATI = NULL;
#endif

#ifdef GL_ATI_draw_buffers
GLboolean GL_ATI_draw_buffers_Flag = GL_FALSE;
PFNGLDRAWBUFFERSATIPROC glDrawBuffersATI = NULL;
#endif

#ifdef GL_ATI_texture_mirror_once
GLboolean GL_ATI_texture_mirror_once_Flag = GL_FALSE;
#endif

#ifdef GL_ATI_texture_float
GLboolean GL_ATI_texture_float_Flag = GL_FALSE;
#endif

#ifdef GL_ATI_texture_env_combine3
GLboolean GL_ATI_texture_env_combine3_Flag = GL_FALSE;
#endif

#ifdef GL_ATIX_texture_env_route
GLboolean GL_ATIX_texture_env_route_Flag = GL_FALSE;
#endif

#ifdef GL_ATIX_vertex_shader_output_point_size
GLboolean GL_ATIX_vertex_shader_output_point_size_Flag = GL_FALSE;
#endif

#ifdef GL_NV_texgen_reflection
GLboolean GL_NV_texgen_reflection_Flag = GL_FALSE;
#endif

#ifdef GL_NV_blend_square
GLboolean GL_NV_blend_square_Flag = GL_FALSE;
#endif

#ifdef GL_NV_point_sprite
GLboolean GL_NV_point_sprite_Flag = GL_FALSE;
PFNGLPOINTPARAMETERINVPROC glPointParameteriNV = NULL; 
PFNGLPOINTPARAMETERIVNVPROC glPointParameterivNV = NULL;
#endif 

#ifdef GL_NV_occlusion_query
GLboolean GL_NV_occlusion_query_Flag = GL_FALSE;
PFNGLGENOCCLUSIONQUERIESNVPROC glGenOcclusionQueriesNV = NULL;
PFNGLDELETEOCCLUSIONQUERIESNVPROC glDeleteOcclusionQueriesNV = NULL;
PFNGLISOCCLUSIONQUERYNVPROC glIsOcclusionQueryNV = NULL;
PFNGLBEGINOCCLUSIONQUERYNVPROC glBeginOcclusionQueryNV = NULL;
PFNGLENDOCCLUSIONQUERYNVPROC glEndOcclusionQueryNV = NULL;
PFNGLGETOCCLUSIONQUERYIVNVPROC glGetOcclusionQueryivNV = NULL;
PFNGLGETOCCLUSIONQUERYUIVNVPROC glGetOcclusionQueryuivNV = NULL;
#endif

#ifdef GL_HP_occlusion_test
GLboolean GL_HP_occlusion_test_Flag = GL_FALSE;
#endif

#ifdef GL_S3_s3tc
GLboolean GL_S3_s3tc_Flag = GL_FALSE;
#endif 

#ifdef GL_SGI_texture_edge_clamp
GLboolean GL_SGI_texture_edge_clamp_Flag = GL_FALSE;
#endif 

#ifdef GL_SGIS_generate_mipmap
GLboolean GL_SGIS_generate_mipmap_Flag = GL_FALSE;
#endif

#ifdef GL_SGIS_texture_border_clamp
GLboolean GL_SGIS_texture_border_clamp_Flag = GL_FALSE;
#endif

#ifdef GL_SGIS_texture_lod
GLboolean GL_SGIS_texture_lod_Flag = GL_FALSE;
#endif 

#ifdef GL_SGIS_texture_lod_bias
GLboolean GL_SGIS_texture_lod_bias_Flag = GL_FALSE;
#endif 

#ifdef GL_SGIS_multitexture
GLboolean GL_SGIS_multitexture_Flag = GL_FALSE;
PFNGLSELECTTEXTURESGISPROC glSelectTextureSGIS = NULL;
PFNGLSELECTTEXTURETRANSFORMSGISPROC glSelectTextureTransformSGIS = NULL;
PFNGLSELECTTEXTURECOORDSETSGISPROC glSelectTextureCoordSetSGIS = NULL;
PFNGLMULTITEXCOORD1DSGISPROC glMultiTexCoord1dSGIS = NULL;
PFNGLMULTITEXCOORD1DVSGISPROC glMultiTexCoord1dvSGIS = NULL;
PFNGLMULTITEXCOORD1FSGISPROC glMultiTexCoord1fSGIS = NULL;
PFNGLMULTITEXCOORD1FVSGISPROC glMultiTexCoord1fvSGIS = NULL;
PFNGLMULTITEXCOORD1ISGISPROC glMultiTexCoord1iSGIS = NULL;
PFNGLMULTITEXCOORD1IVSGISPROC glMultiTexCoord1ivSGIS = NULL;
PFNGLMULTITEXCOORD1SSGISPROC glMultiTexCoord1sSGIS = NULL;
PFNGLMULTITEXCOORD1SVSGISPROC glMultiTexCoord1svSGIS = NULL;
PFNGLMULTITEXCOORD2DSGISPROC glMultiTexCoord2dSGIS = NULL;
PFNGLMULTITEXCOORD2DVSGISPROC glMultiTexCoord2dvSGIS = NULL;
PFNGLMULTITEXCOORD2FSGISPROC glMultiTexCoord2fSGIS = NULL;
PFNGLMULTITEXCOORD2FVSGISPROC glMultiTexCoord2fvSGIS = NULL;
PFNGLMULTITEXCOORD2ISGISPROC glMultiTexCoord2iSGIS = NULL;
PFNGLMULTITEXCOORD2IVSGISPROC glMultiTexCoord2ivSGIS = NULL;
PFNGLMULTITEXCOORD2SSGISPROC glMultiTexCoord2sSGIS = NULL;
PFNGLMULTITEXCOORD2SVSGISPROC glMultiTexCoord2svSGIS = NULL;
PFNGLMULTITEXCOORD3DSGISPROC glMultiTexCoord3dSGIS = NULL;
PFNGLMULTITEXCOORD3DVSGISPROC glMultiTexCoord3dvSGIS = NULL;
PFNGLMULTITEXCOORD3FSGISPROC glMultiTexCoord3fSGIS = NULL;
PFNGLMULTITEXCOORD3FVSGISPROC glMultiTexCoord3fvSGIS = NULL;
PFNGLMULTITEXCOORD3ISGISPROC glMultiTexCoord3iSGIS = NULL;
PFNGLMULTITEXCOORD3IVSGISPROC glMultiTexCoord3ivSGIS = NULL;
PFNGLMULTITEXCOORD3SSGISPROC glMultiTexCoord3sSGIS = NULL;
PFNGLMULTITEXCOORD3SVSGISPROC glMultiTexCoord3svSGIS = NULL;
PFNGLMULTITEXCOORD4DSGISPROC glMultiTexCoord4dSGIS = NULL;
PFNGLMULTITEXCOORD4DVSGISPROC glMultiTexCoord4dvSGIS = NULL;
PFNGLMULTITEXCOORD4FSGISPROC glMultiTexCoord4fSGIS = NULL;
PFNGLMULTITEXCOORD4FVSGISPROC glMultiTexCoord4fvSGIS = NULL;
PFNGLMULTITEXCOORD4ISGISPROC glMultiTexCoord4iSGIS = NULL;
PFNGLMULTITEXCOORD4IVSGISPROC glMultiTexCoord4ivSGIS = NULL;
PFNGLMULTITEXCOORD4SSGISPROC glMultiTexCoord4sSGIS = NULL;
PFNGLMULTITEXCOORD4SVSGISPROC glMultiTexCoord4svSGIS = NULL;
PFNGLMULTITEXCOORD1DSGISPROC glMTexCoord1dSGIS = NULL;
PFNGLMULTITEXCOORD1DVSGISPROC glMTexCoord1dvSGIS = NULL;
PFNGLMULTITEXCOORD1FSGISPROC glMTexCoord1fSGIS = NULL;
PFNGLMULTITEXCOORD1FVSGISPROC glMTexCoord1fvSGIS = NULL;
PFNGLMULTITEXCOORD1ISGISPROC glMTexCoord1iSGIS = NULL;
PFNGLMULTITEXCOORD1IVSGISPROC glMTexCoord1ivSGIS = NULL;
PFNGLMULTITEXCOORD1SSGISPROC glMTexCoord1sSGIS = NULL;
PFNGLMULTITEXCOORD1SVSGISPROC glMTexCoord1svSGIS = NULL;
PFNGLMULTITEXCOORD2DSGISPROC glMTexCoord2dSGIS = NULL;
PFNGLMULTITEXCOORD2DVSGISPROC glMTexCoord2dvSGIS = NULL;
PFNGLMULTITEXCOORD2FSGISPROC glMTexCoord2fSGIS = NULL;
PFNGLMULTITEXCOORD2FVSGISPROC glMTexCoord2fvSGIS = NULL;
PFNGLMULTITEXCOORD2ISGISPROC glMTexCoord2iSGIS = NULL;
PFNGLMULTITEXCOORD2IVSGISPROC glMTexCoord2ivSGIS = NULL;
PFNGLMULTITEXCOORD2SSGISPROC glMTexCoord2sSGIS = NULL;
PFNGLMULTITEXCOORD2SVSGISPROC glMTexCoord2svSGIS = NULL;
PFNGLMULTITEXCOORD3DSGISPROC glMTexCoord3dSGIS = NULL;
PFNGLMULTITEXCOORD3DVSGISPROC glMTexCoord3dvSGIS = NULL;
PFNGLMULTITEXCOORD3FSGISPROC glMTexCoord3fSGIS = NULL;
PFNGLMULTITEXCOORD3FVSGISPROC glMTexCoord3fvSGIS = NULL;
PFNGLMULTITEXCOORD3ISGISPROC glMTexCoord3iSGIS = NULL;
PFNGLMULTITEXCOORD3IVSGISPROC glMTexCoord3ivSGIS = NULL;
PFNGLMULTITEXCOORD3SSGISPROC glMTexCoord3sSGIS = NULL;
PFNGLMULTITEXCOORD3SVSGISPROC glMTexCoord3svSGIS = NULL;
PFNGLMULTITEXCOORD4DSGISPROC glMTexCoord4dSGIS = NULL;
PFNGLMULTITEXCOORD4DVSGISPROC glMTexCoord4dvSGIS = NULL;
PFNGLMULTITEXCOORD4FSGISPROC glMTexCoord4fSGIS = NULL;
PFNGLMULTITEXCOORD4FVSGISPROC glMTexCoord4fvSGIS = NULL;
PFNGLMULTITEXCOORD4ISGISPROC glMTexCoord4iSGIS = NULL;
PFNGLMULTITEXCOORD4IVSGISPROC glMTexCoord4ivSGIS = NULL;
PFNGLMULTITEXCOORD4SSGISPROC glMTexCoord4sSGIS = NULL;
PFNGLMULTITEXCOORD4SVSGISPROC glMTexCoord4svSGIS = NULL;
#endif

#ifdef GL_WIN_swap_hint
GLboolean GL_WIN_swap_hint_Flag = GL_FALSE;
PFNGLADDSWAPHINTRECTWINPROC glAddSwapHintRectWIN = NULL;
#endif

#ifdef GL_KTX_buffer_region
GLboolean GL_KTX_buffer_region_Flag = GL_FALSE;
PFNGLBUFFERREGIONENABLEDEXTPROC glBufferRegionEnabled = NULL;
PFNGLNEWBUFFERREGIONEXTPROC glNewBufferRegion = NULL;
PFNGLDELETEBUFFERREGIONEXTPROC glDeleteBufferRegion = NULL;
PFNGLREADBUFFERREGIONEXTPROC glReadBufferRegion = NULL;
PFNGLDRAWBUFFERREGIONEXTPROC glDrawBufferRegion = NULL;
#endif

#ifdef WGL_ARB_extensions_string
GLboolean WGL_ARB_extensions_string_Flag = GL_FALSE;
PFNWGLGETEXTENSIONSSTRINGARBPROC wglGetExtensionsStringARB = NULL;
#endif

#ifdef WGL_EXT_extensions_string
GLboolean WGL_EXT_extensions_string_Flag = GL_FALSE;
PFNWGLGETEXTENSIONSSTRINGEXTPROC wglGetExtensionsStringEXT = NULL;
#endif

#ifdef WGL_EXT_swap_control
GLboolean WGL_EXT_swap_control_Flag = GL_FALSE;
PFNWGLSWAPINTERVALEXTPROC wglSwapIntervalEXT = NULL;
PFNWGLGETSWAPINTERVALEXTPROC wglGetSwapIntervalEXT = NULL;
#endif

#ifdef WGL_ARB_multisample
GLboolean WGL_ARB_multisample_Flag = GL_FALSE;
#endif

#ifdef WGL_ARB_pixel_format
GLboolean WGL_ARB_pixel_format_Flag = GL_FALSE;
PFNWGLGETPIXELFORMATATTRIBIVARBPROC wglGetPixelFormatAttribivARB = NULL;
PFNWGLGETPIXELFORMATATTRIBFVARBPROC wglGetPixelFormatAttribfvARB = NULL;
PFNWGLCHOOSEPIXELFORMATARBPROC wglChoosePixelFormatARB = NULL;
#endif

#ifdef WGL_ARB_make_current_read
GLboolean WGL_ARB_make_current_read_Flag = GL_FALSE;
PFNWGLMAKECONTEXTCURRENTARBPROC wglMakeContextCurrentARB = NULL;
PFNWGLGETCURRENTREADDCARBPROC wglGetCurrentReadDCARB = NULL;
#endif

#ifdef WGL_ARB_pbuffer
GLboolean WGL_ARB_pbuffer_Flag = GL_FALSE;
PFNWGLCREATEPBUFFERARBPROC wglCreatePbufferARB = NULL;
PFNWGLGETPBUFFERDCARBPROC wglGetPbufferDCARB = NULL;
PFNWGLRELEASEPBUFFERDCARBPROC wglReleasePbufferDCARB = NULL;
PFNWGLDESTROYPBUFFERARBPROC wglDestroyPbufferARB = NULL;
PFNWGLQUERYPBUFFERARBPROC wglQueryPbufferARB = NULL;
#endif

#ifdef WGL_ARB_render_texture
GLboolean WGL_ARB_render_texture_Flag = GL_FALSE;
PFNWGLBINDTEXIMAGEARBPROC wglBindTexImageARB = NULL;
PFNWGLRELEASETEXIMAGEARBPROC wglReleaseTexImageARB = NULL;
PFNWGLSETPBUFFERATTRIBARBPROC wglSetPbufferAttribARB = NULL;
#endif

#ifdef WGL_ATI_pixel_format_float
GLboolean WGL_ATI_pixel_format_float_Flag = GL_FALSE;
#endif


/* OpenGL 1.4 */
#ifdef GL_EXT_multi_draw_arrays
PFNGLMULTIDRAWARRAYSEXTPROC glMultiDrawArrays = NULL;
PFNGLMULTIDRAWELEMENTSEXTPROC glMultiDrawElements = NULL;
#endif

#ifdef GL_EXT_fog_coord
PFNGLFOGCOORDFEXTPROC glFogCoordf = NULL;
PFNGLFOGCOORDDEXTPROC glFogCoordd = NULL;
PFNGLFOGCOORDFVEXTPROC glFogCoordfv = NULL;
PFNGLFOGCOORDDVEXTPROC glFogCoorddv = NULL;
PFNGLFOGCOORDPOINTEREXTPROC glFogCoordPointer = NULL;
#endif

#if GL_EXT_point_parameters
PFNGLPOINTPARAMETERFEXTPROC glPointParameterf = NULL;
PFNGLPOINTPARAMETERFVEXTPROC glPointParameterfv = NULL;
#endif

#ifdef GL_EXT_secondary_color
PFNGLSECONDARYCOLOR3FEXTPROC glSecondaryColor3f = NULL;
PFNGLSECONDARYCOLOR3DEXTPROC glSecondaryColor3d = NULL;
PFNGLSECONDARYCOLOR3BEXTPROC glSecondaryColor3b = NULL;
PFNGLSECONDARYCOLOR3SEXTPROC glSecondaryColor3s = NULL;
PFNGLSECONDARYCOLOR3IEXTPROC glSecondaryColor3i = NULL;
PFNGLSECONDARYCOLOR3UBEXTPROC glSecondaryColor3ub = NULL;
PFNGLSECONDARYCOLOR3USEXTPROC glSecondaryColor3us = NULL;
PFNGLSECONDARYCOLOR3UIEXTPROC glSecondaryColor3ui = NULL;
PFNGLSECONDARYCOLOR3FVEXTPROC glSecondaryColor3fv = NULL;
PFNGLSECONDARYCOLOR3DVEXTPROC glSecondaryColor3dv = NULL;
PFNGLSECONDARYCOLOR3BVEXTPROC glSecondaryColor3bv = NULL;
PFNGLSECONDARYCOLOR3SVEXTPROC glSecondaryColor3sv = NULL;
PFNGLSECONDARYCOLOR3IVEXTPROC glSecondaryColor3iv = NULL;
PFNGLSECONDARYCOLOR3UBVEXTPROC glSecondaryColor3ubv = NULL;
PFNGLSECONDARYCOLOR3USVEXTPROC glSecondaryColor3usv = NULL;
PFNGLSECONDARYCOLOR3UIVEXTPROC glSecondaryColor3uiv = NULL;
PFNGLSECONDARYCOLORPOINTEREXTPROC glSecondaryColorPointer = NULL;
#endif

#ifdef GL_EXT_blend_func_separate
PFNGLBLENDFUNCSEPARATEEXTPROC glBlendFuncSeparate = NULL;
#endif

#ifdef GL_ARB_window_pos
PFNGLWINDOWPOS2DARBPROC glWindowPos2d = NULL;
PFNGLWINDOWPOS2FARBPROC glWindowPos2f = NULL;
PFNGLWINDOWPOS2IARBPROC glWindowPos2i = NULL;
PFNGLWINDOWPOS2SARBPROC glWindowPos2s = NULL;
PFNGLWINDOWPOS2IVARBPROC glWindowPos2iv = NULL;
PFNGLWINDOWPOS2SVARBPROC glWindowPos2sv = NULL;
PFNGLWINDOWPOS2FVARBPROC glWindowPos2fv = NULL;
PFNGLWINDOWPOS2DVARBPROC glWindowPos2dv = NULL;
PFNGLWINDOWPOS3IARBPROC glWindowPos3i = NULL;
PFNGLWINDOWPOS3SARBPROC glWindowPos3s = NULL;
PFNGLWINDOWPOS3FARBPROC glWindowPos3f = NULL;
PFNGLWINDOWPOS3DARBPROC glWindowPos3d = NULL;
PFNGLWINDOWPOS3IVARBPROC glWindowPos3iv = NULL;
PFNGLWINDOWPOS3SVARBPROC glWindowPos3sv = NULL;
PFNGLWINDOWPOS3FVARBPROC glWindowPos3fv = NULL;
PFNGLWINDOWPOS3DVARBPROC glWindowPos3dv = NULL;
#endif

/* OpenGL 1.3 */
#ifdef GL_ARB_multitexture
PFNGLACTIVETEXTUREARBPROC glActiveTexture = NULL;
PFNGLCLIENTACTIVETEXTUREARBPROC glClientActiveTexture = NULL;
PFNGLMULTITEXCOORD1DARBPROC glMultiTexCoord1d = NULL;
PFNGLMULTITEXCOORD1DVARBPROC glMultiTexCoord1dv = NULL;
PFNGLMULTITEXCOORD1FARBPROC glMultiTexCoord1f = NULL;
PFNGLMULTITEXCOORD1FVARBPROC glMultiTexCoord1fv = NULL;
PFNGLMULTITEXCOORD1IARBPROC glMultiTexCoord1i = NULL;
PFNGLMULTITEXCOORD1IVARBPROC glMultiTexCoord1iv = NULL;
PFNGLMULTITEXCOORD1SARBPROC glMultiTexCoord1s = NULL;
PFNGLMULTITEXCOORD1SVARBPROC glMultiTexCoord1sv = NULL;
PFNGLMULTITEXCOORD2DARBPROC glMultiTexCoord2d = NULL;
PFNGLMULTITEXCOORD2DVARBPROC glMultiTexCoord2dv = NULL;
PFNGLMULTITEXCOORD2FARBPROC glMultiTexCoord2f = NULL;
PFNGLMULTITEXCOORD2FVARBPROC glMultiTexCoord2fv = NULL;
PFNGLMULTITEXCOORD2IARBPROC glMultiTexCoord2i = NULL;
PFNGLMULTITEXCOORD2IVARBPROC glMultiTexCoord2iv = NULL;
PFNGLMULTITEXCOORD2SARBPROC glMultiTexCoord2s = NULL;
PFNGLMULTITEXCOORD2SVARBPROC glMultiTexCoord2sv = NULL;
PFNGLMULTITEXCOORD3DARBPROC glMultiTexCoord3d = NULL;
PFNGLMULTITEXCOORD3DVARBPROC glMultiTexCoord3dv = NULL;
PFNGLMULTITEXCOORD3FARBPROC glMultiTexCoord3f = NULL;
PFNGLMULTITEXCOORD3FVARBPROC glMultiTexCoord3fv = NULL;
PFNGLMULTITEXCOORD3IARBPROC glMultiTexCoord3i = NULL;
PFNGLMULTITEXCOORD3IVARBPROC glMultiTexCoord3iv = NULL;
PFNGLMULTITEXCOORD3SARBPROC glMultiTexCoord3s = NULL;
PFNGLMULTITEXCOORD3SVARBPROC glMultiTexCoord3sv = NULL;
PFNGLMULTITEXCOORD4DARBPROC glMultiTexCoord4d = NULL;
PFNGLMULTITEXCOORD4DVARBPROC glMultiTexCoord4dv = NULL;
PFNGLMULTITEXCOORD4FARBPROC glMultiTexCoord4f = NULL;
PFNGLMULTITEXCOORD4FVARBPROC glMultiTexCoord4fv = NULL;
PFNGLMULTITEXCOORD4IARBPROC glMultiTexCoord4i = NULL;
PFNGLMULTITEXCOORD4IVARBPROC glMultiTexCoord4iv = NULL;
PFNGLMULTITEXCOORD4SARBPROC glMultiTexCoord4s = NULL;
PFNGLMULTITEXCOORD4SVARBPROC glMultiTexCoord4sv = NULL;
#endif

#ifdef GL_ARB_texture_compression
PFNGLCOMPRESSEDTEXIMAGE3DARBPROC glCompressedTexImage3D = NULL;
PFNGLCOMPRESSEDTEXIMAGE2DARBPROC glCompressedTexImage2D = NULL;
PFNGLCOMPRESSEDTEXIMAGE1DARBPROC glCompressedTexImage1D = NULL;
PFNGLCOMPRESSEDTEXSUBIMAGE3DARBPROC glCompressedTexSubImage3D = NULL;
PFNGLCOMPRESSEDTEXSUBIMAGE2DARBPROC glCompressedTexSubImage2D = NULL;
PFNGLCOMPRESSEDTEXSUBIMAGE1DARBPROC glCompressedTexSubImage1D = NULL;
PFNGLGETCOMPRESSEDTEXIMAGEARBPROC glGetCompressedTexImage = NULL;
#endif

#ifdef GL_ARB_multisample
PFNGLSAMPLECOVERAGEARBPROC glSampleCoverage = NULL;
#endif

#ifdef GL_ARB_transpose_matrix
PFNGLLOADTRANSPOSEMATRIXFARBPROC glLoadTransposeMatrixf = NULL;
PFNGLLOADTRANSPOSEMATRIXDARBPROC glLoadTransposeMatrixd = NULL;
PFNGLMULTTRANSPOSEMATRIXFARBPROC glMultTransposeMatrixf = NULL;
PFNGLMULTTRANSPOSEMATRIXDARBPROC glMultTransposeMatrixd = NULL;
#endif

/* OpenGL 1.2 */
#ifdef GL_EXT_texture3D
PFNGLTEXIMAGE3DEXTPROC glTexImage3D = NULL;
PFNGLTEXSUBIMAGE3DPROC glTexSubImage3D = NULL;
PFNGLCOPYTEXSUBIMAGE3DPROC glCopyTexSubImage3D = NULL;
#endif

#ifdef GL_EXT_draw_range_elements
PFNGLDRAWRANGEELEMENTSEXTPROC glDrawRangeElements = NULL;
#endif

/* GL2 extensions */
#ifdef GL_GL2_shader_objects
GLboolean GL_GL2_shader_objects_Flag = GL_FALSE;
PFNGLDELETEOBJECTGL2PROC glDeleteObjectGL2 = NULL;
PFNGLDELETEOBJECTSGL2PROC glDeleteObjectsGL2 = NULL;
PFNGLGETHANDLEGL2PROC glGetHandleGL2 = NULL;
PFNGLDETACHOBJECTGL2PROC glDetachObjectGL2 = NULL;
PFNGLOBJECTPARAMETERFGL2PROC glObjectParameterfGL2 = NULL;
PFNGLOBJECTPARAMETERIGL2PROC glObjectParameteriGL2 = NULL;
PFNGLGETOBJECTPARAMETERFVGL2PROC glGetObjectParameterfvGL2 = NULL;
PFNGLGETOBJECTPARAMETERIVGL2PROC glGetObjectParameterivGL2 = NULL;
PFNGLCREATESHADEROBJECTGL2PROC glCreateShaderObjectGL2 = NULL;
PFNGLLOADSHADERGL2PROC glLoadShaderGL2 = NULL;
PFNGLAPPENDSHADERGL2PROC glAppendShaderGL2 = NULL;
PFNGLCOMPILESHADERGL2PROC glCompileShaderGL2 = NULL;
PFNGLGETINFOLOGGL2PROC glGetInfoLogGL2 = NULL;
PFNGLGETSHADERSTRINGGL2PROC glGetShaderStringGL2 = NULL;
PFNGLCREATEPROGRAMOBJECTGL2PROC glCreateProgramObjectGL2 = NULL;
PFNGLATTACHSHADEROBJECTGL2PROC glAttachShaderObjectGL2 = NULL;
PFNGLLINKPROGRAMGL2PROC glLinkProgramGL2 = NULL;
PFNGLUSEPROGRAMOBJECTGL2PROC glUseProgramObjectGL2 = NULL;
/*
//entrypoints for .70 version
PFNGLLOADUNIFORM1FGL2PROC glLoadUniform1fGL2 = NULL;
PFNGLLOADUNIFORM2FGL2PROC glLoadUniform2fGL2 = NULL;
PFNGLLOADUNIFORM3FGL2PROC glLoadUniform3fGL2 = NULL;
PFNGLLOADUNIFORM4FGL2PROC glLoadUniform4fGL2 = NULL;
PFNGLLOADUNIFORM1FVGL2PROC glLoadUniform1fvGL2 = NULL;
PFNGLLOADUNIFORM2FVGL2PROC glLoadUniform2fvGL2 = NULL;
PFNGLLOADUNIFORM3FVGL2PROC glLoadUniform3fvGL2 = NULL;
PFNGLLOADUNIFORM4FVGL2PROC glLoadUniform4fvGL2 = NULL;
PFNGLLOADUNIFORMINTGL2PROC glLoadUniformIntGL2 = NULL;
PFNGLLOADUNIFORMBOOLGL2PROC glLoadUniformBoolGL2 = NULL;
PFNGLLOADUNIFORMARRAY1FVGL2PROC glLoadUniformArray1fvGL2 = NULL;
PFNGLLOADUNIFORMARRAY2FVGL2PROC glLoadUniformArray2fvGL2 = NULL;
PFNGLLOADUNIFORMARRAY3FVGL2PROC glLoadUniformArray3fvGL2 = NULL;
PFNGLLOADUNIFORMARRAY4FVGL2PROC glLoadUniformArray4fvGL2 = NULL;
PFNGLLOADUNIFORMMATRIX2FVGL2PROC glLoadUniformMatrix2fvGL2 = NULL;
PFNGLLOADUNIFORMMATRIX3FVGL2PROC glLoadUniformMatrix3fvGL2 = NULL;
PFNGLLOADUNIFORMMATRIX4FVGL2PROC glLoadUniformMatrix4fvGL2 = NULL;
PFNGLLOADUNIFORMMATRIXARRAY2FVGL2PROC glLoaduniformMatrxArray2fvGL2 = NULL;
PFNGLLOADUNIFORMMATRIXARRAY3FVGL2PROC glLoaduniformMatrxArray3fvGL2 = NULL;
PFNGLLOADUNIFORMMATRIXARRAY4FVGL2PROC glLoaduniformMatrxArray4fvGL2 = NULL;
*/
//entrypoints for .71 version
PFNGLLOADUNIFORMFLOAT1FGL2PROC glLoadUniformFloat1fGL2 = NULL;
PFNGLLOADUNIFORMFLOAT2FGL2PROC glLoadUniformFloat2fGL2 = NULL;
PFNGLLOADUNIFORMFLOAT3FGL2PROC glLoadUniformFloat3fGL2 = NULL;
PFNGLLOADUNIFORMFLOAT4FGL2PROC glLoadUniformFloat4fGL2 = NULL;
PFNGLLOADUNIFORMINT1IGL2PROC glLoadUniformInt1iGL2 = NULL;
PFNGLLOADUNIFORMINT2IGL2PROC glLoadUniformInt2iGL2 = NULL;
PFNGLLOADUNIFORMINT3IGL2PROC glLoadUniformInt3iGL2 = NULL;
PFNGLLOADUNIFORMINT4IGL2PROC glLoadUniformInt4iGL2 = NULL;
PFNGLLOADUNIFORMBOOL1IGL2PROC glLoadUniformBool1iGL2 = NULL;
PFNGLLOADUNIFORMBOOL2IGL2PROC glLoadUniformBool2iGL2 = NULL;
PFNGLLOADUNIFORMBOOL3IGL2PROC glLoadUniformBool3iGL2 = NULL;
PFNGLLOADUNIFORMBOOL4IGL2PROC glLoadUniformBool4iGL2 = NULL;
PFNGLLOADUNIFORMFLOAT1FVGL2PROC glLoadUniformFloat1fvGL2 = NULL;
PFNGLLOADUNIFORMFLOAT2FVGL2PROC glLoadUniformFloat2fvGL2 = NULL;
PFNGLLOADUNIFORMFLOAT3FVGL2PROC glLoadUniformFloat3fvGL2 = NULL;
PFNGLLOADUNIFORMFLOAT4FVGL2PROC glLoadUniformFloat4fvGL2 = NULL;
PFNGLLOADUNIFORMINT1IVGL2PROC glLoadUniformInt1ivGL2 = NULL;
PFNGLLOADUNIFORMINT2IVGL2PROC glLoadUniformInt2ivGL2 = NULL;
PFNGLLOADUNIFORMINT3IVGL2PROC glLoadUniformInt3ivGL2 = NULL;
PFNGLLOADUNIFORMINT4IVGL2PROC glLoadUniformInt4ivGL2 = NULL;
PFNGLLOADUNIFORMBOOL1IVGL2PROC glLoadUniformBool1ivGL2 = NULL;
PFNGLLOADUNIFORMBOOL2IVGL2PROC glLoadUniformBool2ivGL2 = NULL;
PFNGLLOADUNIFORMBOOL3IVGL2PROC glLoadUniformBool3ivGL2 = NULL;
PFNGLLOADUNIFORMBOOL4IVGL2PROC glLoadUniformBool4ivGL2 = NULL;
PFNGLLOADUNIFORMFLOATARRAY1FVGL2PROC glLoadUniformFloatArray1fvGL2 = NULL;
PFNGLLOADUNIFORMFLOATARRAY2FVGL2PROC glLoadUniformFloatArray2fvGL2 = NULL;
PFNGLLOADUNIFORMFLOATARRAY3FVGL2PROC glLoadUniformFloatArray3fvGL2 = NULL;
PFNGLLOADUNIFORMFLOATARRAY4FVGL2PROC glLoadUniformFloatArray4fvGL2 = NULL;
PFNGLLOADUNIFORMINTARRAY1IVGL2PROC glLoadUniformIntArray1ivGL2 = NULL;
PFNGLLOADUNIFORMINTARRAY2IVGL2PROC glLoadUniformIntArray2ivGL2 = NULL;
PFNGLLOADUNIFORMINTARRAY3IVGL2PROC glLoadUniformIntArray3ivGL2 = NULL;
PFNGLLOADUNIFORMINTARRAY4IVGL2PROC glLoadUniformIntArray4ivGL2 = NULL;
PFNGLLOADUNIFORMBOOLARRAY1IVGL2PROC glLoadUniformBoolArray1ivGL2 = NULL;
PFNGLLOADUNIFORMBOOLARRAY2IVGL2PROC glLoadUniformBoolArray2ivGL2 = NULL;
PFNGLLOADUNIFORMBOOLARRAY3IVGL2PROC glLoadUniformBoolArray3ivGL2 = NULL;
PFNGLLOADUNIFORMBOOLARRAY4IVGL2PROC glLoadUniformBoolArray4ivGL2 = NULL;
PFNGLLOADUNIFORMFLOATMATRIX2FVGL2PROC glLoadUniformFloatMatrix2fvGL2 = NULL;
PFNGLLOADUNIFORMFLOATMATRIX3FVGL2PROC glLoadUniformFloatMatrix3fvGL2 = NULL;
PFNGLLOADUNIFORMFLOATMATRIX4FVGL2PROC glLoadUniformFloatMatrix4fvGL2 = NULL;
PFNGLLOADUNIFORMFLOATMATRIXARRAY2FVGL2PROC glLoadUniformFloatMatrixArray2fvGL2 = NULL;
PFNGLLOADUNIFORMFLOATMATRIXARRAY3FVGL2PROC glLoadUniformFloatMatrixArray3fvGL2 = NULL;
PFNGLLOADUNIFORMFLOATMATRIXARRAY4FVGL2PROC glLoadUniformFloatMatrixArray4fvGL2 = NULL;

//common entrypoints
PFNGLGETUNIFORMLOCATIONGL2PROC glGetUniformLocationGL2 = NULL;
PFNGLGETUNIFORMFVGL2PROC glGetUniformfvGL2 = NULL;
PFNGLGETUNIFORMIVGL2PROC glGetUniformivGL2 = NULL;
#endif

#ifdef GL_GL2_vertex_shader
GLboolean GL_GL2_vertex_shader_Flag = GL_FALSE;
PFNGLBINDATTRIBUTELOCATIONGL2PROC glBindAttributeLocationGL2 = NULL;
PFNGLGETACTIVEATTRIBUTESGL2PROC glGetActiveAttributesGL2 = NULL;
#endif

#ifdef GL_GL2_fragment_shader
GLboolean GL_GL2_fragment_shader_Flag = GL_FALSE;
#endif

/* Get Function pointer safely */
#ifdef WIN32
#define SAFE_GET_PROC( func, type, fail)     \
   func = (type) wglGetProcAddress( #func);    \
   fail &= (func != NULL);
#else
#define SAFE_GET_PROC( func, type, fail)     \
   func = (type) glxGetProcAddress( #func);    \
   fail &= (func != NULL);
#endif

/* Determine if a particular extension is supported */
int extensionSupported(const char* string, const char *extension)
{
   const char *start;
   char *where, *terminator;
   
   where = strchr(extension, ' ');
   if (where || *extension == '\0')
      return 0;
   
   
   start = string;
   for (;;) {
      where = (GLubyte *) strstr( start, extension);
      if (!where)
         break;
      terminator = where + strlen(extension);
      if (where == start || *(where - 1) == ' ') {
         if (*terminator == ' ' || *terminator == '\0') {
            return 1;
         }
      }
      start = terminator;
   }
   return 0;
}

int SetupExtension(const char * extension)
{
   
   const char *GLExtensionString = (const char*)glGetString(GL_EXTENSIONS);
   const char *WGLExtensionString = 0;	
   int ret = TRUE;
   
   PFNWGLGETEXTENSIONSSTRINGARBPROC wglGetExtensionsStringARB = 0;
   wglGetExtensionsStringARB = (PFNWGLGETEXTENSIONSSTRINGARBPROC)wglGetProcAddress("wglGetExtensionsStringARB");
   if(wglGetExtensionsStringARB)
   {
      WGLExtensionString = wglGetExtensionsStringARB(wglGetCurrentDC());
   }
   
   if(NULL == extension)
   {
      return FALSE;
   }
#ifdef GL_ARB_window_pos
   else if (0 == strcmp(extension, "GL_ARB_window_pos"))
   {
      if(!extensionSupported(GLExtensionString,extension))
         return FALSE;
      SAFE_GET_PROC( glWindowPos2dARB, PFNGLWINDOWPOS2DARBPROC, ret);
      SAFE_GET_PROC( glWindowPos2fARB, PFNGLWINDOWPOS2FARBPROC, ret);
      SAFE_GET_PROC( glWindowPos2iARB, PFNGLWINDOWPOS2IARBPROC, ret);
      SAFE_GET_PROC( glWindowPos2sARB, PFNGLWINDOWPOS2SARBPROC, ret);
      SAFE_GET_PROC( glWindowPos2ivARB, PFNGLWINDOWPOS2IVARBPROC, ret);
      SAFE_GET_PROC( glWindowPos2svARB, PFNGLWINDOWPOS2SVARBPROC, ret);
      SAFE_GET_PROC( glWindowPos2fvARB, PFNGLWINDOWPOS2FVARBPROC, ret);
      SAFE_GET_PROC( glWindowPos2dvARB, PFNGLWINDOWPOS2DVARBPROC, ret);
      SAFE_GET_PROC( glWindowPos3iARB, PFNGLWINDOWPOS3IARBPROC, ret);
      SAFE_GET_PROC( glWindowPos3sARB, PFNGLWINDOWPOS3SARBPROC, ret);
      SAFE_GET_PROC( glWindowPos3fARB, PFNGLWINDOWPOS3FARBPROC, ret);
      SAFE_GET_PROC( glWindowPos3dARB, PFNGLWINDOWPOS3DARBPROC, ret);
      SAFE_GET_PROC( glWindowPos3ivARB, PFNGLWINDOWPOS3IVARBPROC, ret);
      SAFE_GET_PROC( glWindowPos3svARB, PFNGLWINDOWPOS3SVARBPROC, ret);
      SAFE_GET_PROC( glWindowPos3fvARB, PFNGLWINDOWPOS3FVARBPROC, ret);
      SAFE_GET_PROC( glWindowPos3dvARB, PFNGLWINDOWPOS3DVARBPROC, ret);

      if (ret)
      {
         GL_ARB_window_pos_Flag = GL_TRUE;
      }
   }
#endif /* GL_ARB_window_pos */
#ifdef GL_ARB_multisample
   else if (0 == strcmp(extension, "GL_ARB_multisample"))
   {
      if(!extensionSupported(GLExtensionString,extension))
         return FALSE;

      SAFE_GET_PROC( glSampleCoverageARB, PFNGLSAMPLECOVERAGEARBPROC, ret);

      if (ret)
      {
	      GL_ARB_multisample_Flag = GL_TRUE;
      }
   }
#endif
#ifdef GL_ARB_multitexture
   else if (0 == strcmp(extension, "GL_ARB_multitexture"))
   {
      if(!extensionSupported(GLExtensionString,extension))
         return FALSE;
      SAFE_GET_PROC( glActiveTextureARB, PFNGLACTIVETEXTUREARBPROC, ret);
      SAFE_GET_PROC( glClientActiveTextureARB, PFNGLCLIENTACTIVETEXTUREARBPROC, ret);
      SAFE_GET_PROC( glMultiTexCoord1dARB, PFNGLMULTITEXCOORD1DARBPROC, ret);
      SAFE_GET_PROC( glMultiTexCoord1dvARB, PFNGLMULTITEXCOORD1DVARBPROC, ret);
      SAFE_GET_PROC( glMultiTexCoord1fARB, PFNGLMULTITEXCOORD1FARBPROC, ret);
      SAFE_GET_PROC( glMultiTexCoord1fvARB, PFNGLMULTITEXCOORD1FVARBPROC, ret);
      SAFE_GET_PROC( glMultiTexCoord1iARB, PFNGLMULTITEXCOORD1IARBPROC, ret);
      SAFE_GET_PROC( glMultiTexCoord1ivARB, PFNGLMULTITEXCOORD1IVARBPROC, ret);
      SAFE_GET_PROC( glMultiTexCoord1sARB, PFNGLMULTITEXCOORD1SARBPROC, ret);
      SAFE_GET_PROC( glMultiTexCoord1svARB, PFNGLMULTITEXCOORD1SVARBPROC, ret);
      SAFE_GET_PROC( glMultiTexCoord2dARB, PFNGLMULTITEXCOORD2DARBPROC, ret);
      SAFE_GET_PROC( glMultiTexCoord2dvARB, PFNGLMULTITEXCOORD2DVARBPROC, ret);
      SAFE_GET_PROC( glMultiTexCoord2fARB, PFNGLMULTITEXCOORD2FARBPROC, ret);
      SAFE_GET_PROC( glMultiTexCoord2fvARB, PFNGLMULTITEXCOORD2FVARBPROC, ret);
      SAFE_GET_PROC( glMultiTexCoord2iARB, PFNGLMULTITEXCOORD2IARBPROC, ret);
      SAFE_GET_PROC( glMultiTexCoord2ivARB, PFNGLMULTITEXCOORD2IVARBPROC, ret);
      SAFE_GET_PROC( glMultiTexCoord2sARB, PFNGLMULTITEXCOORD2SARBPROC, ret);
      SAFE_GET_PROC( glMultiTexCoord2svARB, PFNGLMULTITEXCOORD2SVARBPROC, ret);
      SAFE_GET_PROC( glMultiTexCoord3dARB, PFNGLMULTITEXCOORD3DARBPROC, ret);		
      SAFE_GET_PROC( glMultiTexCoord3dvARB, PFNGLMULTITEXCOORD3DVARBPROC, ret);		
      SAFE_GET_PROC( glMultiTexCoord3fARB, PFNGLMULTITEXCOORD3FARBPROC, ret);		
      SAFE_GET_PROC( glMultiTexCoord3fvARB, PFNGLMULTITEXCOORD3FVARBPROC, ret);		
      SAFE_GET_PROC( glMultiTexCoord3iARB, PFNGLMULTITEXCOORD3IARBPROC, ret);		
      SAFE_GET_PROC( glMultiTexCoord3ivARB, PFNGLMULTITEXCOORD3IVARBPROC, ret);		
      SAFE_GET_PROC( glMultiTexCoord3sARB, PFNGLMULTITEXCOORD3SARBPROC, ret);		
      SAFE_GET_PROC( glMultiTexCoord3svARB, PFNGLMULTITEXCOORD3SVARBPROC, ret);		
      SAFE_GET_PROC( glMultiTexCoord4dARB, PFNGLMULTITEXCOORD4DARBPROC, ret);		
      SAFE_GET_PROC( glMultiTexCoord4dvARB, PFNGLMULTITEXCOORD4DVARBPROC, ret);		
      SAFE_GET_PROC( glMultiTexCoord4fARB, PFNGLMULTITEXCOORD4FARBPROC, ret);		
      SAFE_GET_PROC( glMultiTexCoord4fvARB, PFNGLMULTITEXCOORD4FVARBPROC, ret);		
      SAFE_GET_PROC( glMultiTexCoord4iARB, PFNGLMULTITEXCOORD4IARBPROC, ret);		
      SAFE_GET_PROC( glMultiTexCoord4ivARB, PFNGLMULTITEXCOORD4IVARBPROC, ret);		
      SAFE_GET_PROC( glMultiTexCoord4sARB, PFNGLMULTITEXCOORD4SARBPROC, ret);		
      SAFE_GET_PROC( glMultiTexCoord4svARB, PFNGLMULTITEXCOORD4SVARBPROC, ret);		

      if (ret)
      {
         GL_ARB_multitexture_Flag = GL_TRUE;
      }
   }
#endif /* GL_ARB_multitexture */
#ifdef GL_ARB_texture_compression
   else if (0 == strcmp(extension, "GL_ARB_texture_compression"))
   {
      if(!extensionSupported(GLExtensionString,extension))
         return FALSE;
      SAFE_GET_PROC( glCompressedTexImage3DARB, PFNGLCOMPRESSEDTEXIMAGE3DARBPROC, ret);
      SAFE_GET_PROC( glCompressedTexImage2DARB, PFNGLCOMPRESSEDTEXIMAGE2DARBPROC, ret);
      SAFE_GET_PROC( glCompressedTexImage1DARB, PFNGLCOMPRESSEDTEXIMAGE1DARBPROC, ret);
      SAFE_GET_PROC( glCompressedTexSubImage3DARB, PFNGLCOMPRESSEDTEXSUBIMAGE3DARBPROC, ret);
      SAFE_GET_PROC( glCompressedTexSubImage2DARB, PFNGLCOMPRESSEDTEXSUBIMAGE2DARBPROC, ret);
      SAFE_GET_PROC( glCompressedTexSubImage1DARB, PFNGLCOMPRESSEDTEXSUBIMAGE1DARBPROC, ret);
      SAFE_GET_PROC( glGetCompressedTexImageARB, PFNGLGETCOMPRESSEDTEXIMAGEARBPROC, ret);

      if (ret)
      {
         GL_ARB_texture_compression_Flag = GL_TRUE;
      }
   }
#endif /* GL_ARB_texture_compression */
#ifdef GL_ARB_vertex_blend
   else if (0 == strcmp(extension, "GL_ARB_vertex_blend"))
   {
      if(!extensionSupported(GLExtensionString,extension))
         return FALSE;
      SAFE_GET_PROC( glWeightbvARB, PFNGLWEIGHTBVARBPROC, ret);		
      SAFE_GET_PROC( glWeightsvARB, PFNGLWEIGHTSVARBPROC, ret);		
      SAFE_GET_PROC( glWeightivARB, PFNGLWEIGHTIVARBPROC, ret);		
      SAFE_GET_PROC( glWeightfvARB, PFNGLWEIGHTFVARBPROC, ret);		
      SAFE_GET_PROC( glWeightdvARB, PFNGLWEIGHTDVARBPROC, ret);	
      SAFE_GET_PROC( glWeightubvARB, PFNGLWEIGHTUBVARBPROC, ret);		
      SAFE_GET_PROC( glWeightusvARB, PFNGLWEIGHTUSVARBPROC, ret);		
      SAFE_GET_PROC( glWeightuivARB, PFNGLWEIGHTUIVARBPROC, ret);		
      SAFE_GET_PROC( glWeightPointerARB, PFNGLWEIGHTPOINTERARBPROC, ret);		
      SAFE_GET_PROC( glVertexBlendARB, PFNGLVERTEXBLENDARBPROC, ret);

      if (ret)
      {
         GL_ARB_vertex_blend_Flag = GL_TRUE;
      }
   }
#endif /* GL_ARB_vertex_blend */
#ifdef GL_ARB_transpose_matrix
   else if (0 == strcmp(extension, "GL_ARB_transpose_matrix"))
   {
      if(!extensionSupported(GLExtensionString,extension))
         return FALSE;
      SAFE_GET_PROC( glLoadTransposeMatrixfARB, PFNGLLOADTRANSPOSEMATRIXFARBPROC, ret);		
      SAFE_GET_PROC( glLoadTransposeMatrixdARB, PFNGLLOADTRANSPOSEMATRIXDARBPROC, ret);		
      SAFE_GET_PROC( glMultTransposeMatrixfARB, PFNGLMULTTRANSPOSEMATRIXFARBPROC, ret);		
      SAFE_GET_PROC( glMultTransposeMatrixdARB, PFNGLMULTTRANSPOSEMATRIXDARBPROC, ret);		

      if (ret)
      {
         GL_ARB_transpose_matrix_Flag = GL_TRUE;
      }
   }
#endif /* GL_ARB_transpose_matrix */
#ifdef GL_ARB_vertex_program
   else if (0 == strcmp(extension, "GL_ARB_vertex_program"))
   {
      if(!extensionSupported(GLExtensionString,extension))
         return FALSE;
      SAFE_GET_PROC( glVertexAttrib1sARB, PFNGLVERTEXATTRIB1SARBPROC, ret);		
      SAFE_GET_PROC( glVertexAttrib1fARB, PFNGLVERTEXATTRIB1FARBPROC, ret);		
      SAFE_GET_PROC( glVertexAttrib1dARB, PFNGLVERTEXATTRIB1DARBPROC, ret);		
      SAFE_GET_PROC( glVertexAttrib2sARB, PFNGLVERTEXATTRIB2SARBPROC, ret);		
      SAFE_GET_PROC( glVertexAttrib2fARB, PFNGLVERTEXATTRIB2FARBPROC, ret);		
      SAFE_GET_PROC( glVertexAttrib2dARB, PFNGLVERTEXATTRIB2DARBPROC, ret);		
      SAFE_GET_PROC( glVertexAttrib3sARB, PFNGLVERTEXATTRIB3SARBPROC, ret);		
      SAFE_GET_PROC( glVertexAttrib3fARB, PFNGLVERTEXATTRIB3FARBPROC, ret);		
      SAFE_GET_PROC( glVertexAttrib3dARB, PFNGLVERTEXATTRIB3DARBPROC, ret);		
      SAFE_GET_PROC( glVertexAttrib4sARB, PFNGLVERTEXATTRIB4SARBPROC, ret);		
      SAFE_GET_PROC( glVertexAttrib4fARB, PFNGLVERTEXATTRIB4FARBPROC, ret);		
      SAFE_GET_PROC( glVertexAttrib4dARB, PFNGLVERTEXATTRIB4DARBPROC, ret);		
      SAFE_GET_PROC( glVertexAttrib4NubARB, PFNGLVERTEXATTRIB4NUBARBPROC, ret);		
      SAFE_GET_PROC( glVertexAttrib1svARB, PFNGLVERTEXATTRIB1SVARBPROC, ret);		
      SAFE_GET_PROC( glVertexAttrib1fvARB, PFNGLVERTEXATTRIB1FVARBPROC, ret);		
      SAFE_GET_PROC( glVertexAttrib1dvARB, PFNGLVERTEXATTRIB1DVARBPROC, ret);		
      SAFE_GET_PROC( glVertexAttrib2svARB, PFNGLVERTEXATTRIB2SVARBPROC, ret);		
      SAFE_GET_PROC( glVertexAttrib2fvARB, PFNGLVERTEXATTRIB2FVARBPROC, ret);		
      SAFE_GET_PROC( glVertexAttrib2dvARB, PFNGLVERTEXATTRIB2DVARBPROC, ret);		
      SAFE_GET_PROC( glVertexAttrib3svARB, PFNGLVERTEXATTRIB3SVARBPROC, ret);		
      SAFE_GET_PROC( glVertexAttrib3fvARB, PFNGLVERTEXATTRIB3FVARBPROC, ret);		
      SAFE_GET_PROC( glVertexAttrib3dvARB, PFNGLVERTEXATTRIB3DVARBPROC, ret);		
      SAFE_GET_PROC( glVertexAttrib4svARB, PFNGLVERTEXATTRIB4SVARBPROC, ret);		
      SAFE_GET_PROC( glVertexAttrib4fvARB, PFNGLVERTEXATTRIB4FVARBPROC, ret);		
      SAFE_GET_PROC( glVertexAttrib4dvARB, PFNGLVERTEXATTRIB4DVARBPROC, ret);		
      SAFE_GET_PROC( glVertexAttrib4ivARB, PFNGLVERTEXATTRIB4IVARBPROC, ret);		
      SAFE_GET_PROC( glVertexAttrib4bvARB, PFNGLVERTEXATTRIB4BVARBPROC, ret);
      SAFE_GET_PROC( glVertexAttrib4usvARB, PFNGLVERTEXATTRIB4USVARBPROC, ret);		
      SAFE_GET_PROC( glVertexAttrib4ubvARB, PFNGLVERTEXATTRIB4UBVARBPROC, ret);		
      SAFE_GET_PROC( glVertexAttrib4uivARB, PFNGLVERTEXATTRIB4UIVARBPROC, ret);
      SAFE_GET_PROC( glVertexAttrib4NbvARB, PFNGLVERTEXATTRIB4NBVARBPROC, ret);
      SAFE_GET_PROC( glVertexAttrib4NsvARB, PFNGLVERTEXATTRIB4NSVARBPROC, ret);
      SAFE_GET_PROC( glVertexAttrib4NivARB, PFNGLVERTEXATTRIB4NIVARBPROC, ret);
      SAFE_GET_PROC( glVertexAttrib4NubvARB, PFNGLVERTEXATTRIB4NUBVARBPROC, ret);
      SAFE_GET_PROC( glVertexAttrib4NusvARB, PFNGLVERTEXATTRIB4NUSVARBPROC, ret);
      SAFE_GET_PROC( glVertexAttrib4NuivARB, PFNGLVERTEXATTRIB4NUIVARBPROC, ret);
      SAFE_GET_PROC( glVertexAttribPointerARB, PFNGLVERTEXATTRIBPOINTERARBPROC, ret);
      SAFE_GET_PROC( glEnableVertexAttribArrayARB, PFNGLENABLEVERTEXATTRIBARRAYARBPROC, ret);
      SAFE_GET_PROC( glDisableVertexAttribArrayARB, PFNGLDISABLEVERTEXATTRIBARRAYARBPROC, ret);
      SAFE_GET_PROC( glProgramStringARB, PFNGLPROGRAMSTRINGARBPROC, ret);
      SAFE_GET_PROC( glBindProgramARB, PFNGLBINDPROGRAMARBPROC, ret);
      SAFE_GET_PROC( glDeleteProgramsARB, PFNGLDELETEPROGRAMSARBPROC, ret);
      SAFE_GET_PROC( glGenProgramsARB, PFNGLGENPROGRAMSARBPROC, ret);
      SAFE_GET_PROC( glProgramEnvParameter4dARB, PFNGLPROGRAMENVPARAMETER4DARBPROC, ret);
      SAFE_GET_PROC( glProgramEnvParameter4dvARB, PFNGLPROGRAMENVPARAMETER4DVARBPROC, ret);
      SAFE_GET_PROC( glProgramEnvParameter4fARB, PFNGLPROGRAMENVPARAMETER4FARBPROC, ret);
      SAFE_GET_PROC( glProgramEnvParameter4fvARB, PFNGLPROGRAMENVPARAMETER4FVARBPROC, ret);
      SAFE_GET_PROC( glProgramLocalParameter4dARB, PFNGLPROGRAMLOCALPARAMETER4DARBPROC, ret);
      SAFE_GET_PROC( glProgramLocalParameter4dvARB, PFNGLPROGRAMLOCALPARAMETER4DVARBPROC, ret);
      SAFE_GET_PROC( glProgramLocalParameter4fARB, PFNGLPROGRAMLOCALPARAMETER4FARBPROC, ret);
      SAFE_GET_PROC( glProgramLocalParameter4fvARB, PFNGLPROGRAMLOCALPARAMETER4FVARBPROC, ret);
      SAFE_GET_PROC( glGetProgramEnvParameterdvARB, PFNGLGETPROGRAMENVPARAMETERDVARBPROC, ret);
      SAFE_GET_PROC( glGetProgramEnvParameterfvARB, PFNGLGETPROGRAMENVPARAMETERFVARBPROC, ret);
      SAFE_GET_PROC( glGetProgramLocalParameterdvARB, PFNGLGETPROGRAMLOCALPARAMETERDVARBPROC, ret);
      SAFE_GET_PROC( glGetProgramLocalParameterfvARB, PFNGLGETPROGRAMLOCALPARAMETERFVARBPROC, ret);
      SAFE_GET_PROC( glGetProgramivARB, PFNGLGETPROGRAMIVARBPROC, ret);
      SAFE_GET_PROC( glGetProgramStringARB, PFNGLGETPROGRAMSTRINGARBPROC, ret);
      SAFE_GET_PROC( glGetVertexAttribdvARB, PFNGLGETVERTEXATTRIBDVARBPROC, ret);
      SAFE_GET_PROC( glGetVertexAttribfvARB, PFNGLGETVERTEXATTRIBFVARBPROC, ret);
      SAFE_GET_PROC( glGetVertexAttribivARB, PFNGLGETVERTEXATTRIBIVARBPROC, ret);
      SAFE_GET_PROC( glGetVertexAttribPointervARB, PFNGLGETVERTEXATTRIBPOINTERVARBPROC, ret);
      SAFE_GET_PROC( glIsProgramARB, PFNGLISPROGRAMARBPROC, ret);

      if (ret)
      {
         GL_ARB_vertex_program_Flag = GL_TRUE;
      }
   }
#endif
#ifdef GL_ARB_fragment_program
   else if (0 == strcmp(extension, "GL_ARB_fragment_program"))
   {
      if(!extensionSupported(GLExtensionString,extension))
         return FALSE;
      SAFE_GET_PROC( glProgramStringARB, PFNGLPROGRAMSTRINGARBPROC, ret);
      SAFE_GET_PROC( glBindProgramARB, PFNGLBINDPROGRAMARBPROC, ret);
      SAFE_GET_PROC( glDeleteProgramsARB, PFNGLDELETEPROGRAMSARBPROC, ret);
      SAFE_GET_PROC( glGenProgramsARB, PFNGLGENPROGRAMSARBPROC, ret);
      SAFE_GET_PROC( glProgramEnvParameter4dARB, PFNGLPROGRAMENVPARAMETER4DARBPROC, ret);
      SAFE_GET_PROC( glProgramEnvParameter4dvARB, PFNGLPROGRAMENVPARAMETER4DVARBPROC, ret);
      SAFE_GET_PROC( glProgramEnvParameter4fARB, PFNGLPROGRAMENVPARAMETER4FARBPROC, ret);
      SAFE_GET_PROC( glProgramEnvParameter4fvARB, PFNGLPROGRAMENVPARAMETER4FVARBPROC, ret);
      SAFE_GET_PROC( glProgramLocalParameter4dARB, PFNGLPROGRAMLOCALPARAMETER4DARBPROC, ret);
      SAFE_GET_PROC( glProgramLocalParameter4dvARB, PFNGLPROGRAMLOCALPARAMETER4DVARBPROC, ret);
      SAFE_GET_PROC( glProgramLocalParameter4fARB, PFNGLPROGRAMLOCALPARAMETER4FARBPROC, ret);
      SAFE_GET_PROC( glProgramLocalParameter4fvARB, PFNGLPROGRAMLOCALPARAMETER4FVARBPROC, ret);
      SAFE_GET_PROC( glGetProgramEnvParameterdvARB, PFNGLGETPROGRAMENVPARAMETERDVARBPROC, ret);
      SAFE_GET_PROC( glGetProgramEnvParameterfvARB, PFNGLGETPROGRAMENVPARAMETERFVARBPROC, ret);
      SAFE_GET_PROC( glGetProgramLocalParameterdvARB, PFNGLGETPROGRAMLOCALPARAMETERDVARBPROC, ret);
      SAFE_GET_PROC( glGetProgramLocalParameterfvARB, PFNGLGETPROGRAMLOCALPARAMETERFVARBPROC, ret);
      SAFE_GET_PROC( glGetProgramivARB, PFNGLGETPROGRAMIVARBPROC, ret);
      SAFE_GET_PROC( glGetProgramStringARB, PFNGLGETPROGRAMSTRINGARBPROC, ret);
      SAFE_GET_PROC( glIsProgramARB, PFNGLISPROGRAMARBPROC, ret);

      if (ret)
      {
         GL_ARB_fragment_program_Flag = GL_TRUE;
      }
   }
#endif
#ifdef GL_ARB_depth_texture
   else if (0 == strcmp( extension, "GL_ARB_depth_texture"))
   {
      if (!extensionSupported( GLExtensionString, extension))
         return FALSE;

      if (ret)
      {
         GL_ARB_depth_texture_Flag = GL_TRUE;
      }
   }
#endif
#ifdef GL_ARB_shadow
   else if (0 == strcmp( extension, "GL_ARB_shadow"))
   {
      if (!extensionSupported( GLExtensionString, extension))
         return FALSE;

      if (ret)
      {
         GL_ARB_shadow_Flag = GL_TRUE;
      }
   }
#endif
#ifdef GL_ARB_shadow_ambient
   else if (0 == strcmp( extension, "GL_ARB_shadow_ambient"))
   {
      if (!extensionSupported( GLExtensionString, extension))
         return FALSE;

      if (ret)
      {
         GL_ARB_shadow_ambient_Flag = GL_TRUE;
      }
   }
#endif
#ifdef GL_ARB_texture_border_clamp
   else if (0 == strcmp( extension, "GL_ARB_texture_border_clamp"))
   {
      if (!extensionSupported( GLExtensionString, extension))
         return FALSE;

      if (ret)
      {
         GL_ARB_texture_border_clamp_Flag = GL_TRUE;
      }
   }
#endif
#ifdef GL_ARB_texture_mirror_repeat
   else if (0 == strcmp( extension, "GL_ARB_texture_mirror_repeat"))
   {
      if (!extensionSupported( GLExtensionString, extension))
         return FALSE;

      if (ret)
      {
         GL_ARB_texture_mirror_repeat_Flag = GL_TRUE;
      }
   }
#endif
#ifdef GL_ARB_texture_cube_map
   else if (0 == strcmp( extension, "GL_ARB_texture_cube_map"))
   {
      if (!extensionSupported( GLExtensionString, extension))
         return FALSE;
      
      if (ret)
      {
         GL_ARB_texture_cube_map_Flag = GL_TRUE;
      }
   }
#endif 
#ifdef GL_ARB_texture_env_add
   else if (0 == strcmp( extension, "GL_ARB_texture_env_add"))
   {
      if (!extensionSupported( GLExtensionString, extension))
         return FALSE;
      
      if (ret)
      {
         GL_ARB_texture_env_add_Flag = GL_TRUE;
      }
   }
#endif 
#ifdef GL_ARB_texture_env_combine
   else if (0 == strcmp( extension, "GL_ARB_texture_env_combine"))
   {
      if (!extensionSupported( GLExtensionString, extension))
         return FALSE;
      
      if (ret)
      {
         GL_ARB_texture_env_combine_Flag = GL_TRUE;
      }
   }
#endif 
#ifdef GL_ARB_texture_env_crossbar
   else if (0 == strcmp( extension, "GL_ARB_texture_env_crossbar"))
   {
      if (!extensionSupported( GLExtensionString, extension))
         return FALSE;
      
      if (ret)
      {
         GL_ARB_texture_env_crossbar_Flag = GL_TRUE;
      }
   }
#endif 
#ifdef GL_ARB_texture_env_dot3
   else if (0 == strcmp( extension, "GL_ARB_texture_env_dot3"))
   {
      if (!extensionSupported( GLExtensionString, extension))
         return FALSE;
      
      if (ret)
      {
         GL_ARB_texture_env_dot3_Flag = GL_TRUE;
      }
   }
#endif
#ifdef GL_EXT_vertex_array
   else if (0 == strcmp(extension, "GL_EXT_vertex_array"))
   {
      if(!extensionSupported(GLExtensionString,extension))
         return FALSE;
      SAFE_GET_PROC( glArrayElementEXT, PFNGLARRAYELEMENTEXTPROC, ret);
      SAFE_GET_PROC( glDrawArraysEXT, PFNGLDRAWARRAYSEXTPROC, ret);
      SAFE_GET_PROC( glVertexPointerEXT, PFNGLVERTEXPOINTEREXTPROC, ret);
      SAFE_GET_PROC( glNormalPointerEXT, PFNGLNORMALPOINTEREXTPROC, ret);
      SAFE_GET_PROC( glColorPointerEXT, PFNGLCOLORPOINTEREXTPROC, ret);
      SAFE_GET_PROC( glIndexPointerEXT, PFNGLINDEXPOINTEREXTPROC, ret);
      SAFE_GET_PROC( glTexCoordPointerEXT, PFNGLTEXCOORDPOINTEREXTPROC, ret);
      SAFE_GET_PROC( glEdgeFlagPointerEXT, PFNGLEDGEFLAGPOINTEREXTPROC, ret);
      SAFE_GET_PROC( glGetPointervEXT, PFNGLGETPOINTERVEXTPROC, ret);
      
      if (ret)
      {
         GL_EXT_vertex_array_Flag = GL_TRUE;
      }
   }
#endif /* GL_EXT_vertex_array */
#ifdef GL_EXT_compiled_vertex_array
   else if (0 == strcmp(extension, "GL_EXT_compiled_vertex_array"))
   {
      if(!extensionSupported(GLExtensionString,extension))
         return FALSE;
      SAFE_GET_PROC( glLockArraysEXT, PFNGLLOCKARRAYSEXTPROC, ret);
      SAFE_GET_PROC( glUnlockArraysEXT, PFNGLUNLOCKARRAYSEXTPROC, ret);
      
      if (ret)
      {
         GL_EXT_compiled_vertex_array_Flag = GL_TRUE;
      }
   }
#endif /* GL_EXT_compiled_vertex_array */
#ifdef GL_EXT_texture_object
   else if (0 == strcmp(extension, "GL_EXT_texture_object"))
   {
      if(!extensionSupported(GLExtensionString,extension))
         return FALSE;
      SAFE_GET_PROC( glGenTexturesEXT, PFNGLGENTEXTURESEXTPROC, ret);		
      SAFE_GET_PROC( glDeleteTexturesEXT, PFNGLDELETETEXTURESEXTPROC, ret);		
      SAFE_GET_PROC( glBindTextureEXT, PFNGLBINDTEXTUREEXTPROC, ret);		
      SAFE_GET_PROC( glPrioritizeTexturesEXT, PFNGLPRIORITIZETEXTURESEXTPROC, ret);		
      SAFE_GET_PROC( glAreTexturesResidentEXT, PFNGLARETEXTURESRESIDENTEXTPROC, ret);		
      SAFE_GET_PROC( glIsTextureEXT, PFNGLISTEXTUREEXTPROC, ret);		

      if (ret)
      {
         GL_EXT_texture_object_Flag = GL_TRUE;
      }
   }
#endif /* GL_EXT_texture_object */
#ifdef GL_EXT_fog_coord
   else if (0 == strcmp(extension, "GL_EXT_fog_coord"))
   {
      if(!extensionSupported(GLExtensionString,extension))
         return FALSE;
      SAFE_GET_PROC( glFogCoordfEXT, PFNGLFOGCOORDFEXTPROC, ret);		
      SAFE_GET_PROC( glFogCoorddEXT, PFNGLFOGCOORDDEXTPROC, ret);		
      SAFE_GET_PROC( glFogCoordfvEXT, PFNGLFOGCOORDFVEXTPROC, ret);		
      SAFE_GET_PROC( glFogCoorddvEXT, PFNGLFOGCOORDDVEXTPROC, ret);		
      SAFE_GET_PROC( glFogCoordPointerEXT, PFNGLFOGCOORDPOINTEREXTPROC, ret);

      if (ret)
      {
         GL_EXT_fog_coord_Flag = GL_TRUE;
      } 
   }
#endif /* GL_EXT_fog_coord */
#ifdef GL_EXT_secondary_color
   else if (0 == strcmp(extension, "GL_EXT_secondary_color"))
   {
      if(!extensionSupported(GLExtensionString,extension))
         return FALSE;
      SAFE_GET_PROC( glSecondaryColor3fEXT, PFNGLSECONDARYCOLOR3FEXTPROC, ret);		
      SAFE_GET_PROC( glSecondaryColor3dEXT, PFNGLSECONDARYCOLOR3DEXTPROC, ret);		
      SAFE_GET_PROC( glSecondaryColor3bEXT, PFNGLSECONDARYCOLOR3BEXTPROC, ret);		
      SAFE_GET_PROC( glSecondaryColor3sEXT, PFNGLSECONDARYCOLOR3SEXTPROC, ret);	
      SAFE_GET_PROC( glSecondaryColor3iEXT, PFNGLSECONDARYCOLOR3IEXTPROC, ret);		
      SAFE_GET_PROC( glSecondaryColor3ubEXT, PFNGLSECONDARYCOLOR3UBEXTPROC, ret);	
      SAFE_GET_PROC( glSecondaryColor3usEXT, PFNGLSECONDARYCOLOR3USEXTPROC, ret);		
      SAFE_GET_PROC( glSecondaryColor3uiEXT, PFNGLSECONDARYCOLOR3UIEXTPROC, ret);		
      SAFE_GET_PROC( glSecondaryColor3fvEXT, PFNGLSECONDARYCOLOR3FVEXTPROC, ret);	
      SAFE_GET_PROC( glSecondaryColor3dvEXT, PFNGLSECONDARYCOLOR3DVEXTPROC, ret);	
      SAFE_GET_PROC( glSecondaryColor3bvEXT, PFNGLSECONDARYCOLOR3BVEXTPROC, ret);		
      SAFE_GET_PROC( glSecondaryColor3svEXT, PFNGLSECONDARYCOLOR3SVEXTPROC, ret);		
      SAFE_GET_PROC( glSecondaryColor3ivEXT, PFNGLSECONDARYCOLOR3IVEXTPROC, ret);		
      SAFE_GET_PROC( glSecondaryColor3ubvEXT, PFNGLSECONDARYCOLOR3UBVEXTPROC, ret);		
      SAFE_GET_PROC( glSecondaryColor3usvEXT, PFNGLSECONDARYCOLOR3USVEXTPROC, ret);		
      SAFE_GET_PROC( glSecondaryColor3uivEXT, PFNGLSECONDARYCOLOR3UIVEXTPROC, ret);		
      SAFE_GET_PROC( glSecondaryColorPointerEXT, PFNGLSECONDARYCOLORPOINTEREXTPROC, ret);

      if (ret)
      {
         GL_EXT_secondary_color_Flag = GL_TRUE;
      }
   }
#endif /* GL_EXT_secondary_color */
#ifdef GL_EXT_draw_range_elements
   else if (0 == strcmp(extension, "GL_EXT_draw_range_elements"))
   {
      if(!extensionSupported(GLExtensionString,extension))
         return FALSE;
      SAFE_GET_PROC( glDrawRangeElementsEXT, PFNGLDRAWRANGEELEMENTSEXTPROC, ret);

      if (ret)
      {
         GL_EXT_draw_range_elements_Flag = GL_TRUE;
      }
   }
#endif /* GL_EXT_draw_range_elements */
#ifdef GL_EXT_multi_draw_arrays
   else if (0 == strcmp(extension, "GL_EXT_multi_draw_arrays"))
   {
      if(!extensionSupported(GLExtensionString,extension))
         return FALSE;

      SAFE_GET_PROC( glMultiDrawArraysEXT, PFNGLMULTIDRAWARRAYSEXTPROC, ret);
      SAFE_GET_PROC( glMultiDrawElementsEXT, PFNGLMULTIDRAWELEMENTSEXTPROC, ret);

      if (ret)
      {
         GL_EXT_multi_draw_arrays_Flag = GL_TRUE;
      }
   }
#endif /* GL_EXT_multi_draw_arrays */
#ifdef GL_EXT_texture3D
   else if (0 == strcmp(extension, "GL_EXT_texture3D"))
   {
      if(!extensionSupported(GLExtensionString,extension))
         return FALSE;
      SAFE_GET_PROC( glTexImage3DEXT, PFNGLTEXIMAGE3DEXTPROC, ret);    
      SAFE_GET_PROC( glTexSubImage3DEXT, PFNGLTEXSUBIMAGE3DPROC, ret);    
      SAFE_GET_PROC( glCopyTexSubImage3DEXT, PFNGLCOPYTEXSUBIMAGE3DPROC, ret);

      if (ret)
      {
         GL_EXT_texture3D_Flag = GL_TRUE;
      }
   }
#endif /* GL_EXT_texture3D */
#ifdef GL_EXT_point_parameters
   else if (0 == strcmp(extension, "GL_EXT_point_parameters"))
   {
      if(!extensionSupported(GLExtensionString,extension))
         return FALSE;
      SAFE_GET_PROC( glPointParameterfEXT, PFNGLPOINTPARAMETERFEXTPROC, ret);	
      SAFE_GET_PROC( glPointParameterfvEXT, PFNGLPOINTPARAMETERFVEXTPROC, ret);

      if (ret)
      {
         GL_EXT_point_parameters_Flag = GL_TRUE;
      }
   }
#endif /* GL_EXT_point_parameters */
#ifdef GL_ARB_point_parameters
   else if (0 == strcmp(extension, "GL_ARB_point_parameters"))
   {
      if(!extensionSupported(GLExtensionString,extension))
         return FALSE;
      SAFE_GET_PROC( glPointParameterfARB, PFNGLPOINTPARAMETERFEXTPROC, ret);		
      SAFE_GET_PROC( glPointParameterfvARB, PFNGLPOINTPARAMETERFVEXTPROC, ret);

      if (ret)
      {
         GL_ARB_point_parameters_Flag = GL_TRUE;
      }
   }
#endif /* GL_ARB_point_parameters */
#ifdef GL_EXT_vertex_shader
   else if (0 == strcmp(extension, "GL_EXT_vertex_shader"))
   {
      if(!extensionSupported(GLExtensionString,extension))
         return FALSE;
      SAFE_GET_PROC( glBeginVertexShaderEXT, PFNGLBEGINVERTEXSHADEREXTPROC, ret);		
      SAFE_GET_PROC( glEndVertexShaderEXT, PFNGLENDVERTEXSHADEREXTPROC, ret);		
      SAFE_GET_PROC( glBindVertexShaderEXT, PFNGLBINDVERTEXSHADEREXTPROC, ret);		
      SAFE_GET_PROC( glGenVertexShadersEXT, PFNGLGENVERTEXSHADERSEXTPROC, ret);		
      SAFE_GET_PROC( glDeleteVertexShaderEXT, PFNGLDELETEVERTEXSHADEREXTPROC, ret);		
      SAFE_GET_PROC( glShaderOp1EXT, PFNGLSHADEROP1EXTPROC, ret);		
      SAFE_GET_PROC( glShaderOp2EXT, PFNGLSHADEROP2EXTPROC, ret);		
      SAFE_GET_PROC( glShaderOp3EXT, PFNGLSHADEROP3EXTPROC, ret);		
      SAFE_GET_PROC( glSwizzleEXT, PFNGLSWIZZLEEXTPROC, ret);		
      SAFE_GET_PROC( glWriteMaskEXT, PFNGLWRITEMASKEXTPROC, ret);		
      SAFE_GET_PROC( glInsertComponentEXT, PFNGLINSERTCOMPONENTEXTPROC, ret);		
      SAFE_GET_PROC( glExtractComponentEXT, PFNGLEXTRACTCOMPONENTEXTPROC, ret);		
      SAFE_GET_PROC( glGenSymbolsEXT, PFNGLGENSYMBOLSEXTPROC, ret);		
      SAFE_GET_PROC( glSetInvariantEXT, PFNGLSETINVARIANTEXTPROC, ret);		
      SAFE_GET_PROC( glSetLocalConstantEXT, PFNGLSETLOCALCONSTANTEXTPROC, ret);		
      SAFE_GET_PROC( glVariantbvEXT, PFNGLVARIANTBVEXTPROC, ret);		
      SAFE_GET_PROC( glVariantsvEXT, PFNGLVARIANTSVEXTPROC, ret);		
      SAFE_GET_PROC( glVariantivEXT, PFNGLVARIANTIVEXTPROC, ret);		
      SAFE_GET_PROC( glVariantfvEXT, PFNGLVARIANTFVEXTPROC, ret);		
      SAFE_GET_PROC( glVariantdvEXT, PFNGLVARIANTDVEXTPROC, ret);		
      SAFE_GET_PROC( glVariantubvEXT, PFNGLVARIANTUBVEXTPROC, ret);		
      SAFE_GET_PROC( glVariantusvEXT, PFNGLVARIANTUSVEXTPROC, ret);		
      SAFE_GET_PROC( glVariantuivEXT, PFNGLVARIANTUIVEXTPROC, ret);		
      SAFE_GET_PROC( glVariantPointerEXT, PFNGLVARIANTPOINTEREXTPROC, ret);		
      SAFE_GET_PROC( glEnableVariantClientStateEXT, PFNGLENABLEVARIANTCLIENTSTATEEXTPROC, ret);
      SAFE_GET_PROC( glDisableVariantClientStateEXT, PFNGLDISABLEVARIANTCLIENTSTATEEXTPROC, ret);
      SAFE_GET_PROC( glBindLightParameterEXT, PFNGLBINDLIGHTPARAMETEREXTPROC, ret);
      SAFE_GET_PROC( glBindMaterialParameterEXT, PFNGLBINDMATERIALPARAMETEREXTPROC, ret);
      SAFE_GET_PROC( glBindTexGenParameterEXT, PFNGLBINDTEXGENPARAMETEREXTPROC, ret);
      SAFE_GET_PROC( glBindTextureUnitParameterEXT, PFNGLBINDTEXTUREUNITPARAMETEREXTPROC, ret);
      SAFE_GET_PROC( glBindParameterEXT, PFNGLBINDPARAMETEREXTPROC, ret);
      SAFE_GET_PROC( glIsVariantEnabledEXT, PFNGLISVARIANTENABLEDEXTPROC, ret);
      SAFE_GET_PROC( glGetVariantBooleanvEXT, PFNGLGETVARIANTBOOLEANVEXTPROC, ret);
      SAFE_GET_PROC( glGetVariantIntegervEXT, PFNGLGETVARIANTINTEGERVEXTPROC, ret);
      SAFE_GET_PROC( glGetVariantFloatvEXT, PFNGLGETVARIANTFLOATVEXTPROC, ret);
      SAFE_GET_PROC( glGetVariantPointervEXT, PFNGLGETVARIANTPOINTERVEXTPROC, ret);
      SAFE_GET_PROC( glGetInvariantBooleanvEXT, PFNGLGETINVARIANTBOOLEANVEXTPROC, ret);
      SAFE_GET_PROC( glGetInvariantIntegervEXT, PFNGLGETINVARIANTINTEGERVEXTPROC, ret);
      SAFE_GET_PROC( glGetInvariantFloatvEXT, PFNGLGETINVARIANTFLOATVEXTPROC, ret);
      SAFE_GET_PROC( glGetLocalConstantBooleanvEXT, PFNGLGETLOCALCONSTANTBOOLEANVEXTPROC, ret);
      SAFE_GET_PROC( glGetLocalConstantIntegervEXT, PFNGLGETLOCALCONSTANTINTEGERVEXTPROC, ret);
      SAFE_GET_PROC( glGetLocalConstantFloatvEXT, PFNGLGETLOCALCONSTANTFLOATVEXTPROC, ret);

      if (ret)
      {
         GL_EXT_vertex_shader_Flag = GL_TRUE;
      }
   }
#endif /* GL_EXT_vertex_shader */
#ifdef GL_EXT_blend_minmax
   else if (0 == strcmp(extension, "GL_EXT_blend_minmax"))
   {
      if(!extensionSupported(GLExtensionString,extension))
         return FALSE;
      SAFE_GET_PROC( glBlendEquationEXT, PFNGLBLENDEQUATIONEXTPROC, ret);

      if (ret)
      {
         GL_EXT_blend_minmax_Flag = GL_TRUE;
      }
   }
#endif /* GL_EXT_blend_minmax */
#ifdef GL_EXT_blend_func_separate
   else if (0 == strcmp(extension, "GL_EXT_blend_func_separate"))
   {
      if(!extensionSupported(GLExtensionString,extension))
         return FALSE;
      SAFE_GET_PROC( glBlendFuncSeparateEXT, PFNGLBLENDFUNCSEPARATEEXTPROC, ret);

      if (ret)
      {
         GL_EXT_blend_func_separate_Flag = GL_TRUE;
      }
   }
#endif /* GL_EXT_blend_func_separate */
#ifdef GL_EXT_abgr 
   else if (0 == strcmp( extension, "GL_EXT_abgr"))
   {
      if (!extensionSupported( GLExtensionString, extension))
         return FALSE;
      
      GL_EXT_abgr_Flag = GL_TRUE;
   }
#endif 
#ifdef GL_EXT_bgra
   else if (0 == strcmp( extension, "GL_EXT_bgra"))
   {
      if (!extensionSupported( GLExtensionString, extension))
         return FALSE;
      
      GL_EXT_bgra_Flag = GL_TRUE;
   }
#endif 
#ifdef GL_EXT_blend_subtract
   else if (0 == strcmp( extension, "GL_EXT_blend_subtract"))
   {
      if (!extensionSupported( GLExtensionString, extension))
         return FALSE;
      
      GL_EXT_blend_subtract_Flag = GL_TRUE;
   }
#endif
#ifdef GL_EXT_clip_volume_hint
   else if (0 == strcmp( extension, "GL_EXT_clip_volume_hint"))
   {
      if (!extensionSupported( GLExtensionString, extension))
         return FALSE;
      
      GL_EXT_clip_volume_hint_Flag = GL_TRUE;
   }
#endif 
#ifdef GL_EXT_packed_pixels
   else if (0 == strcmp( extension, "GL_EXT_packed_pixels"))
   {
      if (!extensionSupported( GLExtensionString, extension))
         return FALSE;
      
      GL_EXT_packed_pixels_Flag = GL_TRUE;
   }
#endif 
#ifdef GL_EXT_rescale_normal
   else if (0 == strcmp( extension, "GL_EXT_rescale_normal"))
   {
      if (!extensionSupported( GLExtensionString, extension))
         return FALSE;
      
      GL_EXT_rescale_normal_Flag = GL_TRUE;
   }
#endif
#ifdef GL_EXT_separate_specular_color
   else if (0 == strcmp( extension, "GL_EXT_separate_specular_color"))
   {
      if (!extensionSupported( GLExtensionString, extension))
         return FALSE;
      
      GL_EXT_separate_specular_color_Flag = GL_TRUE;
   }
#endif 
#ifdef GL_EXT_texgen_reflection
   else if (0 == strcmp( extension, "GL_EXT_texgen_reflection"))
   {
      if (!extensionSupported( GLExtensionString, extension))
         return FALSE;
      
      GL_EXT_texgen_reflection_Flag = GL_TRUE;
   }
#endif 
#ifdef GL_EXT_texture_cube_map
   else if (0 == strcmp( extension, "GL_EXT_texture_cube_map"))
   {
      if (!extensionSupported( GLExtensionString, extension))
         return FALSE;
      
      GL_EXT_texture_cube_map_Flag = GL_TRUE;
   }
#endif 
#ifdef GL_EXT_texture_compression_s3tc
   else if (0 == strcmp( extension, "GL_EXT_texture_compression_s3tc"))
   {
      if (!extensionSupported( GLExtensionString, extension))
         return FALSE;
      
      GL_EXT_texture_compression_s3tc_Flag = GL_TRUE;
   }
#endif
#ifdef GL_EXT_texture_edge_clamp
   else if (0 == strcmp( extension, "GL_EXT_texture_edge_clamp"))
   {
      if (!extensionSupported( GLExtensionString, extension))
         return FALSE;
      
      GL_EXT_texture_edge_clamp_Flag = GL_TRUE;
   }
#endif 
#ifdef GL_EXT_texture_env_add
   else if (0 == strcmp( extension, "GL_EXT_texture_env_add"))
   {
      if (!extensionSupported( GLExtensionString, extension))
         return FALSE;
      
      GL_EXT_texture_env_add_Flag = GL_TRUE;
   }
#endif
#ifdef GL_EXT_texture_env_combine
   else if (0 == strcmp( extension, "GL_EXT_texture_env_combine"))
   {
      if (!extensionSupported( GLExtensionString, extension))
         return FALSE;
      
      GL_EXT_texture_env_combine_Flag = GL_TRUE;
   }
#endif 
#ifdef GL_EXT_texture_env_dot3
   else if (0 == strcmp( extension, "GL_EXT_texture_env_dot3"))
   {
      if (!extensionSupported( GLExtensionString, extension))
         return FALSE;
      
      GL_EXT_texture_env_dot3_Flag = GL_TRUE;
   }
#endif 
#ifdef GL_EXT_texture_filter_anisotropic
   else if (0 == strcmp( extension, "GL_EXT_texture_filter_anisotropic"))
   {
      if (!extensionSupported( GLExtensionString, extension))
         return FALSE;
      
      GL_EXT_texture_filter_anisotropic_Flag = GL_TRUE;
   }
#endif 
#ifdef GL_EXT_stencil_wrap
   else if (0 == strcmp( extension, "GL_EXT_stencil_wrap"))
   {
      if (!extensionSupported( GLExtensionString, extension))
         return FALSE;
      
      GL_EXT_stencil_wrap_Flag = GL_TRUE;
   }
#endif
#ifdef GL_EXT_blend_color
   else if (0 == strcmp(extension, "GL_EXT_blend_color"))
   {
      if(!extensionSupported(GLExtensionString,extension))
         return FALSE;
      SAFE_GET_PROC( glBlendColorEXT, PFNGLBLENDCOLOREXTPROC, ret);
      
      if (ret)
      {
         GL_EXT_blend_color_Flag = GL_TRUE;
      }
   }
#endif /* GL_EXT_blend_color */
#ifdef GL_EXT_texture_rectangle
   else if (0 == strcmp(extension, "GL_EXT_texture_rectangle"))
   {
      if(!extensionSupported(GLExtensionString,extension))
         return FALSE;
      
      GL_EXT_texture_rectangle_Flag = GL_TRUE;
   }
#endif
#ifdef GL_ATI_envmap_bumpmap
   else if (0 == strcmp(extension, "GL_ATI_envmap_bumpmap"))
   {
      if(!extensionSupported(GLExtensionString,extension))
         return FALSE;
      SAFE_GET_PROC( glTexBumpParameterivATI, PFNGLTEXBUMPPARAMETERIVATIPROC, ret);		
      SAFE_GET_PROC( glTexBumpParameterfvATI, PFNGLTEXBUMPPARAMETERFVATIPROC, ret);		
      SAFE_GET_PROC( glGetTexBumpParameterivATI, PFNGLGETTEXBUMPPARAMETERIVATIPROC, ret);		
      SAFE_GET_PROC( glGetTexBumpParameterfvATI, PFNGLGETTEXBUMPPARAMETERFVATIPROC, ret);

      if (ret)
      {
         GL_ATI_envmap_bumpmap_Flag = GL_TRUE;
      }
   }
#endif /* GL_ATI_envmap_bumpmap */
#ifdef GL_ATI_fragment_shader
   else if (0 == strcmp(extension, "GL_ATI_fragment_shader"))
   {
      if(!extensionSupported(GLExtensionString,extension))
         return FALSE;
      SAFE_GET_PROC( glGenFragmentShadersATI, PFNGLGENFRAGMENTSHADERSATIPROC, ret);
      SAFE_GET_PROC( glBindFragmentShaderATI, PFNGLBINDFRAGMENTSHADERATIPROC, ret);
      SAFE_GET_PROC( glDeleteFragmentShaderATI, PFNGLDELETEFRAGMENTSHADERATIPROC, ret);
      SAFE_GET_PROC( glBeginFragmentShaderATI, PFNGLBEGINFRAGMENTSHADERATIPROC, ret);
      SAFE_GET_PROC( glEndFragmentShaderATI, PFNGLENDFRAGMENTSHADERATIPROC, ret);
      SAFE_GET_PROC( glPassTexCoordATI, PFNGLPASSTEXCOORDATIPROC, ret);
      SAFE_GET_PROC( glSampleMapATI, PFNGLSAMPLEMAPATIPROC, ret);
      SAFE_GET_PROC( glColorFragmentOp1ATI, PFNGLCOLORFRAGMENTOP1ATIPROC, ret);
      SAFE_GET_PROC( glColorFragmentOp2ATI, PFNGLCOLORFRAGMENTOP2ATIPROC, ret);
      SAFE_GET_PROC( glColorFragmentOp3ATI, PFNGLCOLORFRAGMENTOP3ATIPROC, ret);
      SAFE_GET_PROC( glAlphaFragmentOp1ATI, PFNGLALPHAFRAGMENTOP1ATIPROC, ret);
      SAFE_GET_PROC( glAlphaFragmentOp2ATI, PFNGLALPHAFRAGMENTOP2ATIPROC, ret);
      SAFE_GET_PROC( glAlphaFragmentOp3ATI, PFNGLALPHAFRAGMENTOP3ATIPROC, ret);
      SAFE_GET_PROC( glSetFragmentShaderConstantATI, PFNGLSETFRAGMENTSHADERCONSTANTATIPROC, ret);

      if (ret)
      {
         GL_ATI_fragment_shader_Flag = GL_TRUE;
      }
   }
#endif /* GL_ATI_fragment_shader */
#ifdef GL_ATI_vertex_array_object
   else if (0 == strcmp(extension, "GL_ATI_vertex_array_object"))
   {
      if(!extensionSupported(GLExtensionString,extension))
         return FALSE;
      SAFE_GET_PROC( glNewObjectBufferATI, PFNGLNEWOBJECTBUFFERATIPROC, ret);
      SAFE_GET_PROC( glIsObjectBufferATI, PFNGLISOBJECTBUFFERATIPROC, ret);
      SAFE_GET_PROC( glUpdateObjectBufferATI, PFNGLUPDATEOBJECTBUFFERATIPROC, ret);
      SAFE_GET_PROC( glGetObjectBufferfvATI, PFNGLGETOBJECTBUFFERFVATIPROC, ret);
      SAFE_GET_PROC( glGetObjectBufferivATI, PFNGLGETOBJECTBUFFERIVATIPROC, ret);
      SAFE_GET_PROC( glFreeObjectBufferATI, PFNGLFREEOBJECTBUFFERATIPROC, ret);
      SAFE_GET_PROC( glArrayObjectATI, PFNGLARRAYOBJECTATIPROC, ret);
      SAFE_GET_PROC( glGetArrayObjectfvATI, PFNGLGETARRAYOBJECTFVATIPROC, ret);
      SAFE_GET_PROC( glGetArrayObjectivATI, PFNGLGETARRAYOBJECTIVATIPROC, ret);
      SAFE_GET_PROC( glVariantArrayObjectATI, PFNGLVARIANTARRAYOBJECTATIPROC, ret);
      SAFE_GET_PROC( glGetVariantArrayObjectfvATI, PFNGLGETVARIANTARRAYOBJECTFVATIPROC, ret);
      SAFE_GET_PROC( glGetVariantArrayObjectivATI, PFNGLGETVARIANTARRAYOBJECTIVATIPROC, ret);

      if (ret)
      {
         GL_ATI_vertex_array_object_Flag = GL_TRUE;
      }
   }
#endif /* GL_ATI_vertex_array_object */
#ifdef GL_ATI_element_array
   else if (0 == strcmp(extension, "GL_ATI_element_array"))
   {
      if(!extensionSupported(GLExtensionString,extension))
         return FALSE;
      SAFE_GET_PROC( glElementPointerATI, PFNGLELEMENTPOINTERATIPROC, ret);
      SAFE_GET_PROC( glDrawElementArrayATI, PFNGLDRAWELEMENTARRAYATIPROC, ret);
      SAFE_GET_PROC( glDrawRangeElementArrayATI, PFNGLDRAWRANGEELEMENTARRAYATIPROC, ret);

      if (ret)
      {
         GL_ATI_element_array_Flag = GL_TRUE;
      }
   }
#endif /* GL_ATI_element_array */
#ifdef GL_ATI_vertex_attrib_array_object
   else if (0 == strcmp(extension, "GL_ATI_vertex_attrib_array_object"))
   {
      if(!extensionSupported(GLExtensionString,extension))
         return FALSE;
      SAFE_GET_PROC( glVertexAttribArrayObjectATI, PFNGLVERTEXATTRIBARRAYOBJECTATIPROC, ret);
      SAFE_GET_PROC( glVertexAttribArrayObjectfvATI, PFNGLGETVERTEXATTRIBARRAYOBJECTFVATIPROC, ret);
      SAFE_GET_PROC( glVertexAttribArrayObjectivATI, PFNGLGETVERTEXATTRIBARRAYOBJECTIVATIPROC, ret);

      if (ret)
      {
         GL_ATI_vertex_attrib_array_object_Flag = GL_TRUE;
      }
   }
#endif /* GL_ATI_vertex_attrib_array_object */
#ifdef GL_ATI_pn_triangles
   else if (0 == strcmp(extension, "GL_ATI_pn_triangles"))
   {
      if(!extensionSupported(GLExtensionString,extension))
         return FALSE;
      SAFE_GET_PROC( glPNTrianglesiATI, PFNGLPNTRIANGLESIATIPROC, ret);		
      SAFE_GET_PROC( glPNTrianglesfATI, PFNGLPNTRIANGLESFATIPROC, ret);

      if (ret)
      {
         GL_ATI_pn_triangles_Flag = GL_TRUE;
      }
   }
#endif /* GL_ATI_pn_triangles */
#ifdef GL_ATI_vertex_streams
   else if (0 == strcmp(extension, "GL_ATI_vertex_streams"))
   {
      if(!extensionSupported(GLExtensionString,extension))
         return FALSE;
      SAFE_GET_PROC( glClientActiveVertexStreamATI, PFNGLCLIENTACTIVEVERTEXSTREAMATIPROC, ret);		
      SAFE_GET_PROC( glVertexBlendEnviATI, PFNGLVERTEXBLENDENVIATIPROC, ret);		
      SAFE_GET_PROC( glVertexBlendEnvfATI, PFNGLVERTEXBLENDENVFATIPROC, ret);		
      SAFE_GET_PROC( glVertexStream2sATI, PFNGLVERTEXSTREAM2SATIPROC, ret);		
      SAFE_GET_PROC( glVertexStream2svATI, PFNGLVERTEXSTREAM2SVATIPROC, ret);		
      SAFE_GET_PROC( glVertexStream2iATI, PFNGLVERTEXSTREAM2IATIPROC, ret);		
      SAFE_GET_PROC( glVertexStream2ivATI, PFNGLVERTEXSTREAM2IVATIPROC, ret);		
      SAFE_GET_PROC( glVertexStream2fATI, PFNGLVERTEXSTREAM2FATIPROC, ret);		
      SAFE_GET_PROC( glVertexStream2fvATI, PFNGLVERTEXSTREAM2FVATIPROC, ret);		
      SAFE_GET_PROC( glVertexStream2dATI, PFNGLVERTEXSTREAM2DATIPROC, ret);		
      SAFE_GET_PROC( glVertexStream2dvATI, PFNGLVERTEXSTREAM2DVATIPROC, ret);		
      SAFE_GET_PROC( glVertexStream3sATI, PFNGLVERTEXSTREAM3SATIPROC, ret);		
      SAFE_GET_PROC( glVertexStream3svATI, PFNGLVERTEXSTREAM3SVATIPROC, ret);		
      SAFE_GET_PROC( glVertexStream3iATI, PFNGLVERTEXSTREAM3IATIPROC, ret);		
      SAFE_GET_PROC( glVertexStream3ivATI, PFNGLVERTEXSTREAM3IVATIPROC, ret);		
      SAFE_GET_PROC( glVertexStream3fATI, PFNGLVERTEXSTREAM3FATIPROC, ret);		
      SAFE_GET_PROC( glVertexStream3fvATI, PFNGLVERTEXSTREAM3FVATIPROC, ret);		
      SAFE_GET_PROC( glVertexStream3dATI, PFNGLVERTEXSTREAM3DATIPROC, ret);		
      SAFE_GET_PROC( glVertexStream3dvATI, PFNGLVERTEXSTREAM3DVATIPROC, ret);		
      SAFE_GET_PROC( glVertexStream4sATI, PFNGLVERTEXSTREAM4SATIPROC, ret);		
      SAFE_GET_PROC( glVertexStream4svATI, PFNGLVERTEXSTREAM4SVATIPROC, ret);		
      SAFE_GET_PROC( glVertexStream4iATI, PFNGLVERTEXSTREAM4IATIPROC, ret);		
      SAFE_GET_PROC( glVertexStream4ivATI, PFNGLVERTEXSTREAM4IVATIPROC, ret);		
      SAFE_GET_PROC( glVertexStream4fATI, PFNGLVERTEXSTREAM4FATIPROC, ret);		
      SAFE_GET_PROC( glVertexStream4fvATI, PFNGLVERTEXSTREAM4FVATIPROC, ret);		
      SAFE_GET_PROC( glVertexStream4dATI, PFNGLVERTEXSTREAM4DATIPROC, ret);		
      SAFE_GET_PROC( glVertexStream4dvATI, PFNGLVERTEXSTREAM4DVATIPROC, ret);		
      SAFE_GET_PROC( glNormalStream3bATI, PFNGLNORMALSTREAM3BATIPROC, ret);		
      SAFE_GET_PROC( glNormalStream3bvATI, PFNGLNORMALSTREAM3BVATIPROC, ret);		
      SAFE_GET_PROC( glNormalStream3sATI, PFNGLNORMALSTREAM3SATIPROC, ret);		
      SAFE_GET_PROC( glNormalStream3svATI, PFNGLNORMALSTREAM3SVATIPROC, ret);		
      SAFE_GET_PROC( glNormalStream3iATI, PFNGLNORMALSTREAM3IATIPROC, ret);		
      SAFE_GET_PROC( glNormalStream3ivATI, PFNGLNORMALSTREAM3IVATIPROC, ret);		
      SAFE_GET_PROC( glNormalStream3fATI, PFNGLNORMALSTREAM3FATIPROC, ret);		
      SAFE_GET_PROC( glNormalStream3fvATI, PFNGLNORMALSTREAM3FVATIPROC, ret);		
      SAFE_GET_PROC( glNormalStream3dATI, PFNGLNORMALSTREAM3DATIPROC, ret);		
      SAFE_GET_PROC( glNormalStream3dvATI, PFNGLNORMALSTREAM3DVATIPROC, ret);

      if (ret)
      {
         GL_ATI_vertex_streams_Flag = GL_TRUE;
      }
   }
#endif /* GL_ATI_vertex_streams */
#ifdef GL_ATI_separate_stencil
   else if (0 == strcmp(extension, "GL_ATI_separate_stencil"))
   {
      if(!extensionSupported(GLExtensionString,extension))
         return FALSE;
      SAFE_GET_PROC( glStencilOpSeparateATI, PFNGLSTENCILOPSEPARATEATIPROC, ret);		
      SAFE_GET_PROC( glStencilFuncSeparateATI, PFNGLSTENCILFUNCSEPARATEATIPROC, ret);

      if (ret)
      {
         GL_ATI_separate_stencil_Flag = GL_TRUE;
      }
   }
#endif /* GL_ATI_separate_stencil */
#ifdef GL_ATI_draw_buffers
   else if (0 == strcmp(extension, "GL_ATI_draw_buffers"))
   {
      if(!extensionSupported(GLExtensionString,extension))
         return FALSE;

      SAFE_GET_PROC( glDrawBuffersATI, PFNGLDRAWBUFFERSATIPROC, ret);		

      if (ret)
      {
         GL_ATI_draw_buffers_Flag = GL_TRUE;
      }
   }
#endif /* GL_ATI_draw_buffers */
#ifdef GL_ATI_texture_mirror_once
   else if (0 == strcmp( extension, "GL_ATI_texture_mirror_once"))
   {
      if (!extensionSupported( GLExtensionString, extension))
         return FALSE;
      
      GL_ATI_texture_mirror_once_Flag = GL_TRUE;
   }
#endif
#ifdef GL_ATI_texture_float
   else if (0 == strcmp( extension, "GL_ATI_texture_float"))
   {
      if (!extensionSupported( GLExtensionString, extension))
         return FALSE;
      
      GL_ATI_texture_float_Flag = GL_TRUE;
   }
#endif
#ifdef GL_ATI_texture_env_combine3
   else if (0 == strcmp( extension, "GL_ATI_texture_env_combine3"))
   {
      if (!extensionSupported( GLExtensionString, extension))
         return FALSE;
      
      GL_ATI_texture_env_combine3_Flag = GL_TRUE;
   }
#endif
#ifdef GL_ATIX_texture_env_route
   else if (0 == strcmp( extension, "GL_ATIX_texture_env_route"))
   {
      if (!extensionSupported( GLExtensionString, extension))
         return FALSE;
      
      GL_ATIX_texture_env_route_Flag = GL_TRUE;
   }
#endif
#ifdef GL_ATIX_vertex_shader_output_point_size
   else if (0 == strcmp( extension, "GL_ATIX_vertex_shader_output_point_size"))
   {
      if (!extensionSupported( GLExtensionString, extension))
         return FALSE;
      
      GL_ATIX_vertex_shader_output_point_size_Flag = GL_TRUE;
   }
#endif
#ifdef GL_NV_texgen_reflection
   else if (0 == strcmp( extension, "GL_NV_texgen_reflection"))
   {
      if (!extensionSupported( GLExtensionString, extension))
         return FALSE;
      
      GL_NV_texgen_reflection_Flag = GL_TRUE;
   }
#endif 
#ifdef GL_NV_blend_square
   else if (0 == strcmp( extension, "GL_NV_blend_square"))
   {
      if (!extensionSupported( GLExtensionString, extension))
         return FALSE;
      
      GL_NV_blend_square_Flag = GL_TRUE;
   }
#endif
#ifdef GL_NV_point_sprite
   else if (0 == strcmp( extension, "GL_NV_point_sprite"))
   {
      if (!extensionSupported( GLExtensionString, extension))
         return FALSE;
      SAFE_GET_PROC( glPointParameteriNV, PFNGLPOINTPARAMETERINVPROC, ret);		
      SAFE_GET_PROC( glPointParameterivNV, PFNGLPOINTPARAMETERIVNVPROC, ret);		
      
      if (ret)
      {
         GL_NV_point_sprite_Flag = GL_TRUE;
      }
   }
#endif
#ifdef GL_NV_occlusion_query
   else if (0 == strcmp( extension, "GL_NV_occlusion_query"))
   {
      if (!extensionSupported( GLExtensionString, extension))
         return FALSE;
      SAFE_GET_PROC( glGenOcclusionQueriesNV, PFNGLGENOCCLUSIONQUERIESNVPROC, ret);		
      SAFE_GET_PROC( glDeleteOcclusionQueriesNV, PFNGLDELETEOCCLUSIONQUERIESNVPROC, ret);		
      SAFE_GET_PROC( glIsOcclusionQueryNV, PFNGLISOCCLUSIONQUERYNVPROC, ret);		
      SAFE_GET_PROC( glBeginOcclusionQueryNV, PFNGLBEGINOCCLUSIONQUERYNVPROC, ret);		
      SAFE_GET_PROC( glEndOcclusionQueryNV, PFNGLENDOCCLUSIONQUERYNVPROC, ret);		
      SAFE_GET_PROC( glGetOcclusionQueryivNV, PFNGLGETOCCLUSIONQUERYIVNVPROC, ret);		
      SAFE_GET_PROC( glGetOcclusionQueryuivNV, PFNGLGETOCCLUSIONQUERYUIVNVPROC, ret);		
      
      if (ret)
      {
         GL_NV_occlusion_query_Flag = GL_TRUE;
      }
   }
#endif
#ifdef GL_HP_occlusion_test
   else if (0 == strcmp( extension, "GL_HP_occlusion_test"))
   {
      if (!extensionSupported( GLExtensionString, extension))
         return FALSE;
      
      GL_HP_occlusion_test_Flag = GL_TRUE;
   }
#endif
#ifdef GL_S3_s3tc
   else if (0 == strcmp( extension, "GL_S3_s3tc"))
   {
      if (!extensionSupported( GLExtensionString, extension))
         return FALSE;
      
      GL_S3_s3tc_Flag = GL_TRUE;
   }
#endif 
#ifdef GL_SGI_texture_edge_clamp
   else if (0 == strcmp( extension, "GL_SGI_texture_edge_clamp"))
   {
      if (!extensionSupported( GLExtensionString, extension))
         return FALSE;
      
      GL_SGI_texture_edge_clamp_Flag = GL_TRUE;
   }
#endif 
#ifdef GL_SGIS_generate_mipmap
   else if (0 == strcmp( extension, "GL_SGIS_generate_mipmap"))
   {
      if (!extensionSupported( GLExtensionString, extension))
         return FALSE;
      
      GL_SGIS_generate_mipmap_Flag = GL_TRUE;
   }
#endif
#ifdef GL_SGIS_texture_border_clamp
   else if (0 == strcmp( extension, "GL_SGIS_texture_border_clamp"))
   {
      if (!extensionSupported( GLExtensionString, extension))
         return FALSE;
      
      GL_SGIS_texture_border_clamp_Flag = GL_TRUE;
   }
#endif
#ifdef GL_SGIS_texture_lod
   else if (0 == strcmp( extension, "GL_SGIS_texture_lod"))
   {
      if (!extensionSupported( GLExtensionString, extension))
         return FALSE;
      
      GL_SGIS_texture_lod_Flag = GL_TRUE;
   }
#endif
#ifdef GL_SGIS_texture_lod_bias
   else if (0 == strcmp( extension, "GL_SGIS_texture_lod_bias"))
   {
      if (!extensionSupported( GLExtensionString, extension))
         return FALSE;
      
      GL_SGIS_texture_lod_bias_Flag = GL_TRUE;
   }
#endif
#ifdef GL_SGIS_multitexture
   else if (0 == strcmp(extension, "GL_SGIS_multitexture"))
   {
      if(!extensionSupported(GLExtensionString,extension))
         return FALSE;
      SAFE_GET_PROC( glSelectTextureSGIS, PFNGLSELECTTEXTURESGISPROC, ret);		
      SAFE_GET_PROC( glSelectTextureTransformSGIS, PFNGLSELECTTEXTURETRANSFORMSGISPROC, ret);		
      SAFE_GET_PROC( glSelectTextureCoordSetSGIS, PFNGLSELECTTEXTURECOORDSETSGISPROC, ret);		
      SAFE_GET_PROC( glMultiTexCoord1dSGIS, PFNGLMULTITEXCOORD1DSGISPROC, ret);		
      SAFE_GET_PROC( glMultiTexCoord1dvSGIS, PFNGLMULTITEXCOORD1DVSGISPROC, ret);		
      SAFE_GET_PROC( glMultiTexCoord1fSGIS, PFNGLMULTITEXCOORD1FSGISPROC, ret);		
      SAFE_GET_PROC( glMultiTexCoord1fvSGIS, PFNGLMULTITEXCOORD1FVSGISPROC, ret);		
      SAFE_GET_PROC( glMultiTexCoord1iSGIS, PFNGLMULTITEXCOORD1ISGISPROC, ret);		
      SAFE_GET_PROC( glMultiTexCoord1ivSGIS, PFNGLMULTITEXCOORD1IVSGISPROC, ret);		
      SAFE_GET_PROC( glMultiTexCoord1sSGIS, PFNGLMULTITEXCOORD1SSGISPROC, ret);		
      SAFE_GET_PROC( glMultiTexCoord1svSGIS, PFNGLMULTITEXCOORD1SVSGISPROC, ret);
      SAFE_GET_PROC( glMultiTexCoord2dSGIS, PFNGLMULTITEXCOORD2DSGISPROC, ret);
      SAFE_GET_PROC( glMultiTexCoord2dvSGIS, PFNGLMULTITEXCOORD2DVSGISPROC, ret);
      SAFE_GET_PROC( glMultiTexCoord2fSGIS, PFNGLMULTITEXCOORD2FSGISPROC, ret);
      SAFE_GET_PROC( glMultiTexCoord2fvSGIS, PFNGLMULTITEXCOORD2FVSGISPROC, ret);
      SAFE_GET_PROC( glMultiTexCoord2iSGIS, PFNGLMULTITEXCOORD2ISGISPROC, ret);
      SAFE_GET_PROC( glMultiTexCoord2ivSGIS, PFNGLMULTITEXCOORD2IVSGISPROC, ret);
      SAFE_GET_PROC( glMultiTexCoord2sSGIS, PFNGLMULTITEXCOORD2SSGISPROC, ret);		
      SAFE_GET_PROC( glMultiTexCoord2svSGIS, PFNGLMULTITEXCOORD2SVSGISPROC, ret);		
      SAFE_GET_PROC( glMultiTexCoord3dSGIS, PFNGLMULTITEXCOORD3DSGISPROC, ret);		
      SAFE_GET_PROC( glMultiTexCoord3dvSGIS, PFNGLMULTITEXCOORD3DVSGISPROC, ret);	
      SAFE_GET_PROC( glMultiTexCoord3fSGIS, PFNGLMULTITEXCOORD3FSGISPROC, ret);		
      SAFE_GET_PROC( glMultiTexCoord3fvSGIS, PFNGLMULTITEXCOORD3FVSGISPROC, ret);	
      SAFE_GET_PROC( glMultiTexCoord3iSGIS, PFNGLMULTITEXCOORD3ISGISPROC, ret);		
      SAFE_GET_PROC( glMultiTexCoord3ivSGIS, PFNGLMULTITEXCOORD3IVSGISPROC, ret);		
      SAFE_GET_PROC( glMultiTexCoord3sSGIS, PFNGLMULTITEXCOORD3SSGISPROC, ret);		
      SAFE_GET_PROC( glMultiTexCoord3svSGIS, PFNGLMULTITEXCOORD3SVSGISPROC, ret);		
      SAFE_GET_PROC( glMultiTexCoord4dSGIS, PFNGLMULTITEXCOORD4DSGISPROC, ret);		
      SAFE_GET_PROC( glMultiTexCoord4dvSGIS, PFNGLMULTITEXCOORD4DVSGISPROC, ret);	
      SAFE_GET_PROC( glMultiTexCoord4fSGIS, PFNGLMULTITEXCOORD4FSGISPROC, ret);		
      SAFE_GET_PROC( glMultiTexCoord4fvSGIS, PFNGLMULTITEXCOORD4FVSGISPROC, ret);		
      SAFE_GET_PROC( glMultiTexCoord4iSGIS, PFNGLMULTITEXCOORD4ISGISPROC, ret);	
      SAFE_GET_PROC( glMultiTexCoord4ivSGIS, PFNGLMULTITEXCOORD4IVSGISPROC, ret);		
      SAFE_GET_PROC( glMultiTexCoord4sSGIS, PFNGLMULTITEXCOORD4SSGISPROC, ret);		
      SAFE_GET_PROC( glMultiTexCoord4svSGIS, PFNGLMULTITEXCOORD4SVSGISPROC, ret);		
      SAFE_GET_PROC( glMTexCoord1dSGIS, PFNGLMULTITEXCOORD1DSGISPROC, ret);		
      SAFE_GET_PROC( glMTexCoord1dvSGIS, PFNGLMULTITEXCOORD1DVSGISPROC, ret);		
      SAFE_GET_PROC( glMTexCoord1fSGIS, PFNGLMULTITEXCOORD1FSGISPROC, ret);		
      SAFE_GET_PROC( glMTexCoord1fvSGIS, PFNGLMULTITEXCOORD1FVSGISPROC, ret);		
      SAFE_GET_PROC( glMTexCoord1iSGIS, PFNGLMULTITEXCOORD1ISGISPROC, ret);		
      SAFE_GET_PROC( glMTexCoord1ivSGIS, PFNGLMULTITEXCOORD1IVSGISPROC, ret);		
      SAFE_GET_PROC( glMTexCoord1sSGIS, PFNGLMULTITEXCOORD1SSGISPROC, ret);		
      SAFE_GET_PROC( glMTexCoord1svSGIS, PFNGLMULTITEXCOORD1SVSGISPROC, ret);		
      SAFE_GET_PROC( glMTexCoord2dSGIS, PFNGLMULTITEXCOORD2DSGISPROC, ret);		
      SAFE_GET_PROC( glMTexCoord2dvSGIS, PFNGLMULTITEXCOORD2DVSGISPROC, ret);		
      SAFE_GET_PROC( glMTexCoord2fSGIS, PFNGLMULTITEXCOORD2FSGISPROC, ret);		
      SAFE_GET_PROC( glMTexCoord2fvSGIS, PFNGLMULTITEXCOORD2FVSGISPROC, ret);		
      SAFE_GET_PROC( glMTexCoord2iSGIS, PFNGLMULTITEXCOORD2ISGISPROC, ret);		
      SAFE_GET_PROC( glMTexCoord2ivSGIS, PFNGLMULTITEXCOORD2IVSGISPROC, ret);		
      SAFE_GET_PROC( glMTexCoord2sSGIS, PFNGLMULTITEXCOORD2SSGISPROC, ret);		
      SAFE_GET_PROC( glMTexCoord2svSGIS, PFNGLMULTITEXCOORD2SVSGISPROC, ret);		
      SAFE_GET_PROC( glMTexCoord3dSGIS, PFNGLMULTITEXCOORD3DSGISPROC, ret);		
      SAFE_GET_PROC( glMTexCoord3dvSGIS, PFNGLMULTITEXCOORD3DVSGISPROC, ret);		
      SAFE_GET_PROC( glMTexCoord3fSGIS, PFNGLMULTITEXCOORD3FSGISPROC, ret);		
      SAFE_GET_PROC( glMTexCoord3fvSGIS, PFNGLMULTITEXCOORD3FVSGISPROC, ret);		
      SAFE_GET_PROC( glMTexCoord3iSGIS, PFNGLMULTITEXCOORD3ISGISPROC, ret);		
      SAFE_GET_PROC( glMTexCoord3ivSGIS, PFNGLMULTITEXCOORD3IVSGISPROC, ret);		
      SAFE_GET_PROC( glMTexCoord3sSGIS, PFNGLMULTITEXCOORD3SSGISPROC, ret);		
      SAFE_GET_PROC( glMTexCoord3svSGIS, PFNGLMULTITEXCOORD3SVSGISPROC, ret);		
      SAFE_GET_PROC( glMTexCoord4dSGIS, PFNGLMULTITEXCOORD4DSGISPROC, ret);		
      SAFE_GET_PROC( glMTexCoord4dvSGIS, PFNGLMULTITEXCOORD4DVSGISPROC, ret);		
      SAFE_GET_PROC( glMTexCoord4fSGIS, PFNGLMULTITEXCOORD4FSGISPROC, ret);		
      SAFE_GET_PROC( glMTexCoord4fvSGIS, PFNGLMULTITEXCOORD4FVSGISPROC, ret);		
      SAFE_GET_PROC( glMTexCoord4iSGIS, PFNGLMULTITEXCOORD4ISGISPROC, ret);		
      SAFE_GET_PROC( glMTexCoord4ivSGIS, PFNGLMULTITEXCOORD4IVSGISPROC, ret);		
      SAFE_GET_PROC( glMTexCoord4sSGIS, PFNGLMULTITEXCOORD4SSGISPROC, ret);		
      SAFE_GET_PROC( glMTexCoord4svSGIS, PFNGLMULTITEXCOORD4SVSGISPROC, ret);		

      if (ret)
      {
         GL_SGIS_multitexture_Flag = GL_TRUE;
      }
   }
#endif /* GL_SGIS_multitexture */
#ifdef GL_WIN_swap_hint
   else if (0 == strcmp(extension, "GL_WIN_swap_hint"))
   {
      if(!extensionSupported(GLExtensionString,extension))
         return FALSE;
      SAFE_GET_PROC( glAddSwapHintRectWIN, PFNGLADDSWAPHINTRECTWINPROC, ret);
      
      if (ret)
      {
         GL_WIN_swap_hint_Flag = GL_TRUE;
      }
   }
#endif /* GL_WIN_swap_hint */
#ifdef GL_KTX_buffer_region
   else if (0 == strcmp(extension, "GL_KTX_buffer_region"))
   {
      if(!extensionSupported(GLExtensionString,extension))
         return FALSE;
      SAFE_GET_PROC( glBufferRegionEnabled, PFNGLBUFFERREGIONENABLEDEXTPROC, ret);		
      SAFE_GET_PROC( glNewBufferRegion, PFNGLNEWBUFFERREGIONEXTPROC, ret);		
      SAFE_GET_PROC( glDeleteBufferRegion, PFNGLDELETEBUFFERREGIONEXTPROC, ret);		
      SAFE_GET_PROC( glReadBufferRegion, PFNGLREADBUFFERREGIONEXTPROC, ret);		
      SAFE_GET_PROC( glDrawBufferRegion, PFNGLDRAWBUFFERREGIONEXTPROC, ret);		

      if (ret)
      {
         GL_KTX_buffer_region_Flag = GL_TRUE;
      }
   }
#endif /* GL_KTX_buffer_region */
#ifdef WGL_ARB_extensions_string
   else if (0 == strcmp(extension, "WGL_ARB_extensions_string"))
   {
      SAFE_GET_PROC( wglGetExtensionsStringARB, PFNWGLGETEXTENSIONSSTRINGARBPROC, ret);

      if (ret)
      {
         WGL_ARB_extensions_string_Flag = GL_TRUE;
      }
   }
#endif /* WGL_ARB_extensions_string */
#ifdef WGL_EXT_extensions_string
   else if (0 == strcmp(extension, "WGL_EXT_extensions_string"))
   {
      SAFE_GET_PROC( wglGetExtensionsStringEXT, PFNWGLGETEXTENSIONSSTRINGEXTPROC, ret);

      if (ret)
      {
         WGL_EXT_extensions_string_Flag = GL_TRUE;
      }
   }
#endif /* WGL_EXT_extensions_string */
#ifdef WGL_EXT_swap_control
   else if (0 == strcmp(extension, "WGL_EXT_swap_control"))
   {
      if((NULL == wglGetExtensionsStringARB) ||
         (!extensionSupported(WGLExtensionString,extension)))
         return FALSE;
      SAFE_GET_PROC( wglSwapIntervalEXT, PFNWGLSWAPINTERVALEXTPROC, ret);
      SAFE_GET_PROC( wglGetSwapIntervalEXT, PFNWGLGETSWAPINTERVALEXTPROC, ret);

      if (ret)
      {
         WGL_EXT_swap_control_Flag = GL_TRUE;
      }
   }
#endif /* WGL_EXT_swap_control */
#ifdef WGL_ARB_pixel_format
   else if (0 == strcmp(extension, "WGL_ARB_pixel_format"))
   {
      if((NULL == wglGetExtensionsStringARB) ||
         (!extensionSupported(WGLExtensionString,extension)))
         return FALSE;
      SAFE_GET_PROC( wglGetPixelFormatAttribivARB, PFNWGLGETPIXELFORMATATTRIBIVARBPROC, ret);		
      SAFE_GET_PROC( wglGetPixelFormatAttribfvARB, PFNWGLGETPIXELFORMATATTRIBFVARBPROC, ret);		
      SAFE_GET_PROC( wglChoosePixelFormatARB, PFNWGLCHOOSEPIXELFORMATARBPROC, ret);

      if (ret)
      {
         WGL_ARB_pixel_format_Flag = GL_TRUE;
      }
   }
#endif /* WGL_ARB_pixel_format */
#ifdef WGL_ARB_make_current_read
   else if (0 == strcmp(extension, "WGL_ARB_make_current_read"))
   {
      if((NULL == wglGetExtensionsStringARB) ||
         (!extensionSupported(WGLExtensionString,extension)))
         return FALSE;
      SAFE_GET_PROC( wglMakeContextCurrentARB, PFNWGLMAKECONTEXTCURRENTARBPROC, ret);
      SAFE_GET_PROC( wglGetCurrentReadDCARB, PFNWGLGETCURRENTREADDCARBPROC, ret);

      if (ret)
      {
         WGL_ARB_make_current_read_Flag = GL_TRUE;
      }
   }
#endif /* WGL_ARB_make_current_read */
#ifdef WGL_ARB_pbuffer
   else if (0 == strcmp(extension, "WGL_ARB_pbuffer"))
   {
      if((NULL == wglGetExtensionsStringARB) ||
         (!extensionSupported(WGLExtensionString,extension)))
         return FALSE;
      SAFE_GET_PROC( wglCreatePbufferARB, PFNWGLCREATEPBUFFERARBPROC, ret);
      SAFE_GET_PROC( wglGetPbufferDCARB, PFNWGLGETPBUFFERDCARBPROC, ret);
      SAFE_GET_PROC( wglReleasePbufferDCARB, PFNWGLRELEASEPBUFFERDCARBPROC, ret);
      SAFE_GET_PROC( wglDestroyPbufferARB, PFNWGLDESTROYPBUFFERARBPROC, ret);
      SAFE_GET_PROC( wglQueryPbufferARB, PFNWGLQUERYPBUFFERARBPROC, ret);

      if (ret)
      {
         WGL_ARB_pbuffer_Flag = GL_TRUE;
      }
   }
#endif /* WGL_ARB_pbuffer */
#ifdef WGL_ARB_render_texture
   else if (0 == strcmp(extension, "WGL_ARB_render_texture"))
   {
      if((NULL == wglGetExtensionsStringARB) ||
         (!extensionSupported(WGLExtensionString,extension)))
         return FALSE;
      SAFE_GET_PROC( wglBindTexImageARB, PFNWGLBINDTEXIMAGEARBPROC, ret);
      SAFE_GET_PROC( wglReleaseTexImageARB, PFNWGLRELEASETEXIMAGEARBPROC, ret);
      SAFE_GET_PROC( wglSetPbufferAttribARB, PFNWGLSETPBUFFERATTRIBARBPROC, ret);

      if (ret)
      {
         WGL_ARB_render_texture_Flag = GL_TRUE;
      }
   }
#endif /* WGL_ARB_render_texture */
#ifdef WGL_ARB_multisample
   else if (0 == strcmp(extension, "WGL_ARB_multisample"))
   {
      if((NULL == wglGetExtensionsStringARB) ||
         (!extensionSupported(WGLExtensionString,extension)))
         return FALSE;

      if (ret)
      {
         WGL_ARB_multisample_Flag = GL_TRUE;
      }
   }
#endif /* WGL_ARB_multisample */
#ifdef WGL_ATI_pixel_format_float
   else if (0 == strcmp(extension, "WGL_ATI_pixel_format_float"))
   {
      if((NULL == wglGetExtensionsStringARB) ||
         (!extensionSupported(WGLExtensionString,extension)))
         return FALSE;

      if (ret)
      {
         WGL_ATI_pixel_format_float_Flag = GL_TRUE;
      }
   }
#endif /* WGL_ARB_render_texture */
   
#ifdef GL_GL2_shader_objects
   else if (0 == strcmp(extension, "GL_GL2_shader_objects"))
   {
      if(!extensionSupported(GLExtensionString,extension))
         return FALSE;
      SAFE_GET_PROC( glDeleteObjectGL2, PFNGLDELETEOBJECTGL2PROC, ret);
      SAFE_GET_PROC( glDeleteObjectsGL2, PFNGLDELETEOBJECTSGL2PROC, ret);
      SAFE_GET_PROC( glGetHandleGL2, PFNGLGETHANDLEGL2PROC, ret);
      SAFE_GET_PROC( glDetachObjectGL2, PFNGLDETACHOBJECTGL2PROC, ret);
      SAFE_GET_PROC( glObjectParameterfGL2, PFNGLOBJECTPARAMETERFGL2PROC, ret);
      SAFE_GET_PROC( glObjectParameteriGL2, PFNGLOBJECTPARAMETERIGL2PROC, ret);
      SAFE_GET_PROC( glGetObjectParameterfvGL2, PFNGLGETOBJECTPARAMETERFVGL2PROC, ret);
      SAFE_GET_PROC( glGetObjectParameterivGL2, PFNGLGETOBJECTPARAMETERIVGL2PROC, ret);
      SAFE_GET_PROC( glCreateShaderObjectGL2, PFNGLCREATESHADEROBJECTGL2PROC, ret);
      SAFE_GET_PROC( glLoadShaderGL2, PFNGLLOADSHADERGL2PROC, ret);
      SAFE_GET_PROC( glAppendShaderGL2, PFNGLAPPENDSHADERGL2PROC, ret);
      SAFE_GET_PROC( glCompileShaderGL2 , PFNGLCOMPILESHADERGL2PROC, ret);
      SAFE_GET_PROC( glGetInfoLogGL2, PFNGLGETINFOLOGGL2PROC, ret);
      SAFE_GET_PROC( glGetShaderStringGL2, PFNGLGETSHADERSTRINGGL2PROC, ret);
      SAFE_GET_PROC( glCreateProgramObjectGL2, PFNGLCREATEPROGRAMOBJECTGL2PROC, ret);
      SAFE_GET_PROC( glAttachShaderObjectGL2, PFNGLATTACHSHADEROBJECTGL2PROC, ret);
      SAFE_GET_PROC( glLinkProgramGL2, PFNGLLINKPROGRAMGL2PROC, ret);
      SAFE_GET_PROC( glUseProgramObjectGL2, PFNGLUSEPROGRAMOBJECTGL2PROC, ret);
/*
      //entrypoints for verison .70
      SAFE_GET_PROC( glLoadUniform1fGL2, PFNGLLOADUNIFORM1FGL2PROC, ret);
      SAFE_GET_PROC( glLoadUniform2fGL2, PFNGLLOADUNIFORM2FGL2PROC, ret);
      SAFE_GET_PROC( glLoadUniform3fGL2, PFNGLLOADUNIFORM3FGL2PROC, ret);
      SAFE_GET_PROC( glLoadUniform4fGL2, PFNGLLOADUNIFORM4FGL2PROC, ret);
      SAFE_GET_PROC( glLoadUniform1fvGL2, PFNGLLOADUNIFORM1FVGL2PROC, ret);
      SAFE_GET_PROC( glLoadUniform2fvGL2, PFNGLLOADUNIFORM2FVGL2PROC, ret);
      SAFE_GET_PROC( glLoadUniform3fvGL2, PFNGLLOADUNIFORM3FVGL2PROC, ret);
      SAFE_GET_PROC( glLoadUniform4fvGL2, PFNGLLOADUNIFORM4FVGL2PROC, ret);
      SAFE_GET_PROC( glLoadUniformIntGL2, PFNGLLOADUNIFORMINTGL2PROC, ret);
      SAFE_GET_PROC( glLoadUniformBoolGL2, PFNGLLOADUNIFORMBOOLGL2PROC, ret);
      SAFE_GET_PROC( glLoadUniformArray1fvGL2, PFNGLLOADUNIFORMARRAY1FVGL2PROC, ret);
      SAFE_GET_PROC( glLoadUniformArray2fvGL2, PFNGLLOADUNIFORMARRAY2FVGL2PROC, ret);
      SAFE_GET_PROC( glLoadUniformArray3fvGL2, PFNGLLOADUNIFORMARRAY3FVGL2PROC, ret);
      SAFE_GET_PROC( glLoadUniformArray4fvGL2, PFNGLLOADUNIFORMARRAY4FVGL2PROC, ret);
      SAFE_GET_PROC( glLoadUniformMatrix2fvGL2, PFNGLLOADUNIFORMMATRIX2FVGL2PROC, ret);
      SAFE_GET_PROC( glLoadUniformMatrix3fvGL2, PFNGLLOADUNIFORMMATRIX3FVGL2PROC, ret);
      SAFE_GET_PROC( glLoadUniformMatrix4fvGL2, PFNGLLOADUNIFORMMATRIX4FVGL2PROC, ret);
      SAFE_GET_PROC( glLoaduniformMatrxArray2fvGL2, PFNGLLOADUNIFORMMATRIXARRAY2FVGL2PROC, ret);
      SAFE_GET_PROC( glLoaduniformMatrxArray3fvGL2, PFNGLLOADUNIFORMMATRIXARRAY3FVGL2PROC, ret);
      SAFE_GET_PROC( glLoaduniformMatrxArray4fvGL2, PFNGLLOADUNIFORMMATRIXARRAY4FVGL2PROC, ret);
*/
      //entrypoints for .71 version
      SAFE_GET_PROC( glLoadUniformFloat1fGL2, PFNGLLOADUNIFORMFLOAT1FGL2PROC, ret);
      SAFE_GET_PROC( glLoadUniformFloat2fGL2, PFNGLLOADUNIFORMFLOAT2FGL2PROC, ret);
      SAFE_GET_PROC( glLoadUniformFloat3fGL2, PFNGLLOADUNIFORMFLOAT3FGL2PROC, ret);
      SAFE_GET_PROC( glLoadUniformFloat4fGL2, PFNGLLOADUNIFORMFLOAT4FGL2PROC, ret);
      SAFE_GET_PROC( glLoadUniformInt1iGL2, PFNGLLOADUNIFORMINT1IGL2PROC, ret);
      SAFE_GET_PROC( glLoadUniformInt2iGL2, PFNGLLOADUNIFORMINT2IGL2PROC, ret);
      SAFE_GET_PROC( glLoadUniformInt3iGL2, PFNGLLOADUNIFORMINT3IGL2PROC, ret);
      SAFE_GET_PROC( glLoadUniformInt4iGL2, PFNGLLOADUNIFORMINT4IGL2PROC, ret);
      SAFE_GET_PROC( glLoadUniformBool1iGL2, PFNGLLOADUNIFORMBOOL1IGL2PROC, ret);
      SAFE_GET_PROC( glLoadUniformBool2iGL2, PFNGLLOADUNIFORMBOOL2IGL2PROC, ret);
      SAFE_GET_PROC( glLoadUniformBool3iGL2, PFNGLLOADUNIFORMBOOL3IGL2PROC, ret);
      SAFE_GET_PROC( glLoadUniformBool4iGL2, PFNGLLOADUNIFORMBOOL4IGL2PROC, ret);
      SAFE_GET_PROC( glLoadUniformFloat1fvGL2, PFNGLLOADUNIFORMFLOAT1FVGL2PROC, ret);
      SAFE_GET_PROC( glLoadUniformFloat2fvGL2, PFNGLLOADUNIFORMFLOAT2FVGL2PROC, ret);
      SAFE_GET_PROC( glLoadUniformFloat3fvGL2, PFNGLLOADUNIFORMFLOAT3FVGL2PROC, ret);
      SAFE_GET_PROC( glLoadUniformFloat4fvGL2, PFNGLLOADUNIFORMFLOAT4FVGL2PROC, ret);
      SAFE_GET_PROC( glLoadUniformInt1ivGL2, PFNGLLOADUNIFORMINT1IVGL2PROC, ret);
      SAFE_GET_PROC( glLoadUniformInt2ivGL2, PFNGLLOADUNIFORMINT2IVGL2PROC, ret);
      SAFE_GET_PROC( glLoadUniformInt3ivGL2, PFNGLLOADUNIFORMINT3IVGL2PROC, ret);
      SAFE_GET_PROC( glLoadUniformInt4ivGL2, PFNGLLOADUNIFORMINT4IVGL2PROC, ret);
      SAFE_GET_PROC( glLoadUniformBool1ivGL2, PFNGLLOADUNIFORMBOOL1IVGL2PROC, ret);
      SAFE_GET_PROC( glLoadUniformBool2ivGL2, PFNGLLOADUNIFORMBOOL2IVGL2PROC, ret);
      SAFE_GET_PROC( glLoadUniformBool3ivGL2, PFNGLLOADUNIFORMBOOL3IVGL2PROC, ret);
      SAFE_GET_PROC( glLoadUniformBool4ivGL2, PFNGLLOADUNIFORMBOOL4IVGL2PROC, ret);
      SAFE_GET_PROC( glLoadUniformFloatArray1fvGL2, PFNGLLOADUNIFORMFLOATARRAY1FVGL2PROC, ret);
      SAFE_GET_PROC( glLoadUniformFloatArray2fvGL2, PFNGLLOADUNIFORMFLOATARRAY2FVGL2PROC, ret);
      SAFE_GET_PROC( glLoadUniformFloatArray3fvGL2, PFNGLLOADUNIFORMFLOATARRAY3FVGL2PROC, ret);
      SAFE_GET_PROC( glLoadUniformFloatArray4fvGL2, PFNGLLOADUNIFORMFLOATARRAY4FVGL2PROC, ret);
      SAFE_GET_PROC( glLoadUniformIntArray1ivGL2, PFNGLLOADUNIFORMINTARRAY1IVGL2PROC, ret);
      SAFE_GET_PROC( glLoadUniformIntArray2ivGL2, PFNGLLOADUNIFORMINTARRAY2IVGL2PROC, ret);
      SAFE_GET_PROC( glLoadUniformIntArray3ivGL2, PFNGLLOADUNIFORMINTARRAY3IVGL2PROC, ret);
      SAFE_GET_PROC( glLoadUniformIntArray4ivGL2, PFNGLLOADUNIFORMINTARRAY4IVGL2PROC, ret);
      SAFE_GET_PROC( glLoadUniformBoolArray1ivGL2, PFNGLLOADUNIFORMBOOLARRAY1IVGL2PROC, ret);
      SAFE_GET_PROC( glLoadUniformBoolArray2ivGL2, PFNGLLOADUNIFORMBOOLARRAY2IVGL2PROC, ret);
      SAFE_GET_PROC( glLoadUniformBoolArray3ivGL2, PFNGLLOADUNIFORMBOOLARRAY3IVGL2PROC, ret);
      SAFE_GET_PROC( glLoadUniformBoolArray4ivGL2, PFNGLLOADUNIFORMBOOLARRAY4IVGL2PROC, ret);
      SAFE_GET_PROC( glLoadUniformFloatMatrix2fvGL2, PFNGLLOADUNIFORMFLOATMATRIX2FVGL2PROC, ret);
      SAFE_GET_PROC( glLoadUniformFloatMatrix3fvGL2, PFNGLLOADUNIFORMFLOATMATRIX3FVGL2PROC, ret);
      SAFE_GET_PROC( glLoadUniformFloatMatrix4fvGL2, PFNGLLOADUNIFORMFLOATMATRIX4FVGL2PROC, ret);
      SAFE_GET_PROC( glLoadUniformFloatMatrixArray2fvGL2, PFNGLLOADUNIFORMFLOATMATRIXARRAY2FVGL2PROC, ret);
      SAFE_GET_PROC( glLoadUniformFloatMatrixArray3fvGL2, PFNGLLOADUNIFORMFLOATMATRIXARRAY3FVGL2PROC, ret);
      SAFE_GET_PROC( glLoadUniformFloatMatrixArray4fvGL2, PFNGLLOADUNIFORMFLOATMATRIXARRAY4FVGL2PROC, ret);

      //common entrypoints
      SAFE_GET_PROC( glGetUniformLocationGL2, PFNGLGETUNIFORMLOCATIONGL2PROC, ret);
      SAFE_GET_PROC( glGetUniformfvGL2, PFNGLGETUNIFORMFVGL2PROC, ret);
      SAFE_GET_PROC( glGetUniformivGL2, PFNGLGETUNIFORMIVGL2PROC, ret);

      if (ret)
      {
         GL_GL2_shader_objects_Flag = GL_TRUE;
      }
   }
#endif /* GL_GL2_shader_objects */
#ifdef GL_GL2_vertex_shader
   else if (0 == strcmp(extension, "GL_GL2_vertex_shader"))
   {
      if(!extensionSupported(GLExtensionString,extension))
         return FALSE;
      SAFE_GET_PROC( glBindAttributeLocationGL2, PFNGLBINDATTRIBUTELOCATIONGL2PROC, ret);
      SAFE_GET_PROC( glGetActiveAttributesGL2, PFNGLGETACTIVEATTRIBUTESGL2PROC, ret);

      if (ret)
      {
         GL_GL2_vertex_shader_Flag = GL_TRUE;
      }
   }
#endif
#ifdef GL_GL2_fragment_shader
   else if (0 == strcmp(extension, "GL_GL2_fragment_shader"))
   {
      if(!extensionSupported(GLExtensionString,extension))
         return FALSE;
      
      GL_GL2_fragment_shader_Flag = GL_TRUE;
      
   }
#endif
   else if(extensionSupported(GLExtensionString,extension) || 
      (wglGetExtensionsStringARB && !extensionSupported(WGLExtensionString,extension)))
   {
    		return TRUE;
   }
   else
   {
      return FALSE;
   }
   return ret;
}


int SetupExtensionsFromString(const char * OrigExtensionString)
{
   char *ExtensionString;
   unsigned int StrLen = strlen(OrigExtensionString);
   char * Extension;
   int ret = TRUE;

   if ( !(ExtensionString = (char*) malloc( StrLen+1)))
   {
      return FALSE;
   }
   
   /* Convert From 'const char *' to 'char *' */
   
   strcpy(ExtensionString, OrigExtensionString);
   
   /* Setup All the Extensions in this string */
   Extension = strtok( ExtensionString, " ");
   while( Extension != NULL )
   {
      if(!SetupExtension(Extension))
      {
         ret = FALSE;
      }
      Extension = strtok( NULL, " ");
   }

   free(ExtensionString);
   
   return ret;
}


/* Initialize GL 1.2 entrypoints */
int SetupGL1_2()
{
   int majorVersion;
   int minorVersion;
   const char* version;
   int ret = TRUE;
   
   version = (const char*)glGetString(GL_VERSION);
   majorVersion = atoi(version);
   version = strchr( version, '.');
   version++;
   minorVersion = atoi(version);
   
   /* check for 1.2 versions string */
   if ( (majorVersion == 1) && (minorVersion >=2))
   {
      /* 3D texture */
      SAFE_GET_PROC( glTexImage3D, PFNGLTEXIMAGE3DEXTPROC, ret);
      SAFE_GET_PROC( glTexSubImage3D, PFNGLTEXSUBIMAGE3DPROC, ret);
      SAFE_GET_PROC( glCopyTexSubImage3D, PFNGLCOPYTEXSUBIMAGE3DPROC, ret);
      
      /* Draw range elements */
      SAFE_GET_PROC( glDrawRangeElements, PFNGLDRAWRANGEELEMENTSEXTPROC, ret);

      return ret;
   }
   
   return FALSE;
}

/* Initialize GL 1.3 entrypoints */
int SetupGL1_3()
{
   int majorVersion;
   int minorVersion;
   const char* version;
   int ret = TRUE;
   
   version = (const char*)glGetString(GL_VERSION);
   majorVersion = atoi(version);
   version = strchr( version, '.');
   version++;
   minorVersion = atoi(version);
   
   /* check for 1.3 versions string */
   if ((majorVersion == 1) && (minorVersion >=3))
   {

      /* multitexture */
      SAFE_GET_PROC( glActiveTexture, PFNGLACTIVETEXTUREARBPROC, ret);
      SAFE_GET_PROC( glClientActiveTexture, PFNGLCLIENTACTIVETEXTUREARBPROC, ret);
      SAFE_GET_PROC( glMultiTexCoord1d, PFNGLMULTITEXCOORD1DARBPROC, ret);
      SAFE_GET_PROC( glMultiTexCoord1dv, PFNGLMULTITEXCOORD1DVARBPROC, ret);
      SAFE_GET_PROC( glMultiTexCoord1f, PFNGLMULTITEXCOORD1FARBPROC, ret);
      SAFE_GET_PROC( glMultiTexCoord1fv, PFNGLMULTITEXCOORD1FVARBPROC, ret);
      SAFE_GET_PROC( glMultiTexCoord1i, PFNGLMULTITEXCOORD1IARBPROC, ret);
      SAFE_GET_PROC( glMultiTexCoord1iv, PFNGLMULTITEXCOORD1IVARBPROC, ret);
      SAFE_GET_PROC( glMultiTexCoord1s, PFNGLMULTITEXCOORD1SARBPROC, ret);
      SAFE_GET_PROC( glMultiTexCoord1sv, PFNGLMULTITEXCOORD1SVARBPROC, ret);
      SAFE_GET_PROC( glMultiTexCoord2d, PFNGLMULTITEXCOORD2DARBPROC, ret);
      SAFE_GET_PROC( glMultiTexCoord2dv, PFNGLMULTITEXCOORD2DVARBPROC, ret);
      SAFE_GET_PROC( glMultiTexCoord2f, PFNGLMULTITEXCOORD2FARBPROC, ret);
      SAFE_GET_PROC( glMultiTexCoord2fv, PFNGLMULTITEXCOORD2FVARBPROC, ret);
      SAFE_GET_PROC( glMultiTexCoord2i, PFNGLMULTITEXCOORD2IARBPROC, ret);
      SAFE_GET_PROC( glMultiTexCoord2iv, PFNGLMULTITEXCOORD2IVARBPROC, ret);
      SAFE_GET_PROC( glMultiTexCoord2s, PFNGLMULTITEXCOORD2SARBPROC, ret);
      SAFE_GET_PROC( glMultiTexCoord2sv, PFNGLMULTITEXCOORD2SVARBPROC, ret);
      SAFE_GET_PROC( glMultiTexCoord3d, PFNGLMULTITEXCOORD3DARBPROC, ret);
      SAFE_GET_PROC( glMultiTexCoord3dv, PFNGLMULTITEXCOORD3DVARBPROC, ret);
      SAFE_GET_PROC( glMultiTexCoord3f, PFNGLMULTITEXCOORD3FARBPROC, ret);
      SAFE_GET_PROC( glMultiTexCoord3fv, PFNGLMULTITEXCOORD3FVARBPROC, ret);
      SAFE_GET_PROC( glMultiTexCoord3i, PFNGLMULTITEXCOORD3IARBPROC, ret);
      SAFE_GET_PROC( glMultiTexCoord3iv, PFNGLMULTITEXCOORD3IVARBPROC, ret);
      SAFE_GET_PROC( glMultiTexCoord3s, PFNGLMULTITEXCOORD3SARBPROC, ret);
      SAFE_GET_PROC( glMultiTexCoord3sv, PFNGLMULTITEXCOORD3SVARBPROC, ret);
      SAFE_GET_PROC( glMultiTexCoord4d, PFNGLMULTITEXCOORD4DARBPROC, ret);
      SAFE_GET_PROC( glMultiTexCoord4dv, PFNGLMULTITEXCOORD4DVARBPROC, ret);
      SAFE_GET_PROC( glMultiTexCoord4f, PFNGLMULTITEXCOORD4FARBPROC, ret);
      SAFE_GET_PROC( glMultiTexCoord4fv, PFNGLMULTITEXCOORD4FVARBPROC, ret);
      SAFE_GET_PROC( glMultiTexCoord4i, PFNGLMULTITEXCOORD4IARBPROC, ret);
      SAFE_GET_PROC( glMultiTexCoord4iv, PFNGLMULTITEXCOORD4IVARBPROC, ret);
      SAFE_GET_PROC( glMultiTexCoord4s, PFNGLMULTITEXCOORD4SARBPROC, ret);
      SAFE_GET_PROC( glMultiTexCoord4sv, PFNGLMULTITEXCOORD4SVARBPROC, ret);
      
      /* transpose matrix */
      SAFE_GET_PROC( glLoadTransposeMatrixf, PFNGLLOADTRANSPOSEMATRIXFARBPROC, ret);
      SAFE_GET_PROC( glLoadTransposeMatrixd, PFNGLLOADTRANSPOSEMATRIXDARBPROC, ret);
      SAFE_GET_PROC( glMultTransposeMatrixf, PFNGLMULTTRANSPOSEMATRIXFARBPROC, ret);
      SAFE_GET_PROC( glMultTransposeMatrixd, PFNGLMULTTRANSPOSEMATRIXDARBPROC, ret);
      
      /* Compressed texture */
      SAFE_GET_PROC( glCompressedTexImage3D, PFNGLCOMPRESSEDTEXIMAGE3DARBPROC, ret);
      SAFE_GET_PROC( glCompressedTexImage2D, PFNGLCOMPRESSEDTEXIMAGE2DARBPROC, ret);
      SAFE_GET_PROC( glCompressedTexImage1D, PFNGLCOMPRESSEDTEXIMAGE1DARBPROC, ret);
      SAFE_GET_PROC( glCompressedTexSubImage3D, PFNGLCOMPRESSEDTEXSUBIMAGE3DARBPROC, ret);
      SAFE_GET_PROC( glCompressedTexSubImage2D, PFNGLCOMPRESSEDTEXSUBIMAGE2DARBPROC, ret);
      SAFE_GET_PROC( glCompressedTexSubImage1D, PFNGLCOMPRESSEDTEXSUBIMAGE1DARBPROC, ret);
      SAFE_GET_PROC( glGetCompressedTexImage, PFNGLGETCOMPRESSEDTEXIMAGEARBPROC, ret);
      
	  /* Multisample */
      SAFE_GET_PROC( glSampleCoverage, PFNGLSAMPLECOVERAGEARBPROC, ret);

      return SetupGL1_2() && ret;
   }
   
   return FALSE;
}

/* Initialize GL 1.4 entrypoints */
int SetupGL1_4()
{
   int majorVersion;
   int minorVersion;
   const char* version;
   int ret = TRUE;
   
   version = (const char*)glGetString(GL_VERSION);
   majorVersion = atoi(version);
   version = strchr( version, '.');
   version++;
   minorVersion = atoi(version);
   
   /* check for 1.4 versions string */
   if ((majorVersion == 1) && (minorVersion >=4))
   {  
      /* point parameter */
      SAFE_GET_PROC( glPointParameterf, PFNGLPOINTPARAMETERFEXTPROC, ret);		
      SAFE_GET_PROC( glPointParameterfv, PFNGLPOINTPARAMETERFVEXTPROC, ret);

      /* secondary color */
      SAFE_GET_PROC( glSecondaryColor3f, PFNGLSECONDARYCOLOR3FEXTPROC, ret);		
      SAFE_GET_PROC( glSecondaryColor3d, PFNGLSECONDARYCOLOR3DEXTPROC, ret);		
      SAFE_GET_PROC( glSecondaryColor3b, PFNGLSECONDARYCOLOR3BEXTPROC, ret);		
      SAFE_GET_PROC( glSecondaryColor3s, PFNGLSECONDARYCOLOR3SEXTPROC, ret);	
      SAFE_GET_PROC( glSecondaryColor3i, PFNGLSECONDARYCOLOR3IEXTPROC, ret);		
      SAFE_GET_PROC( glSecondaryColor3ub, PFNGLSECONDARYCOLOR3UBEXTPROC, ret);	
      SAFE_GET_PROC( glSecondaryColor3us, PFNGLSECONDARYCOLOR3USEXTPROC, ret);		
      SAFE_GET_PROC( glSecondaryColor3ui, PFNGLSECONDARYCOLOR3UIEXTPROC, ret);		
      SAFE_GET_PROC( glSecondaryColor3fv, PFNGLSECONDARYCOLOR3FVEXTPROC, ret);	
      SAFE_GET_PROC( glSecondaryColor3dv, PFNGLSECONDARYCOLOR3DVEXTPROC, ret);	
      SAFE_GET_PROC( glSecondaryColor3bv, PFNGLSECONDARYCOLOR3BVEXTPROC, ret);		
      SAFE_GET_PROC( glSecondaryColor3sv, PFNGLSECONDARYCOLOR3SVEXTPROC, ret);		
      SAFE_GET_PROC( glSecondaryColor3iv, PFNGLSECONDARYCOLOR3IVEXTPROC, ret);		
      SAFE_GET_PROC( glSecondaryColor3ubv, PFNGLSECONDARYCOLOR3UBVEXTPROC, ret);		
      SAFE_GET_PROC( glSecondaryColor3usv, PFNGLSECONDARYCOLOR3USVEXTPROC, ret);		
      SAFE_GET_PROC( glSecondaryColor3uiv, PFNGLSECONDARYCOLOR3UIVEXTPROC, ret);		
      SAFE_GET_PROC( glSecondaryColorPointer, PFNGLSECONDARYCOLORPOINTEREXTPROC, ret);
       
      /* fog coord */
      SAFE_GET_PROC( glFogCoordf, PFNGLFOGCOORDFEXTPROC, ret);		
      SAFE_GET_PROC( glFogCoordd, PFNGLFOGCOORDDEXTPROC, ret);		
      SAFE_GET_PROC( glFogCoordfv, PFNGLFOGCOORDFVEXTPROC, ret);		
      SAFE_GET_PROC( glFogCoorddv, PFNGLFOGCOORDDVEXTPROC, ret);		
      SAFE_GET_PROC( glFogCoordPointer, PFNGLFOGCOORDPOINTEREXTPROC, ret);

      /* window pos */
      SAFE_GET_PROC( glWindowPos2d, PFNGLWINDOWPOS2DARBPROC, ret);
      SAFE_GET_PROC( glWindowPos2f, PFNGLWINDOWPOS2FARBPROC, ret);
      SAFE_GET_PROC( glWindowPos2i, PFNGLWINDOWPOS2IARBPROC, ret);
      SAFE_GET_PROC( glWindowPos2s, PFNGLWINDOWPOS2SARBPROC, ret);
      SAFE_GET_PROC( glWindowPos2iv, PFNGLWINDOWPOS2IVARBPROC, ret);
      SAFE_GET_PROC( glWindowPos2sv, PFNGLWINDOWPOS2SVARBPROC, ret);
      SAFE_GET_PROC( glWindowPos2fv, PFNGLWINDOWPOS2FVARBPROC, ret);
      SAFE_GET_PROC( glWindowPos2dv, PFNGLWINDOWPOS2DVARBPROC, ret);
      SAFE_GET_PROC( glWindowPos3i, PFNGLWINDOWPOS3IARBPROC, ret);
      SAFE_GET_PROC( glWindowPos3s, PFNGLWINDOWPOS3SARBPROC, ret);
      SAFE_GET_PROC( glWindowPos3f, PFNGLWINDOWPOS3FARBPROC, ret);
      SAFE_GET_PROC( glWindowPos3d, PFNGLWINDOWPOS3DARBPROC, ret);
      SAFE_GET_PROC( glWindowPos3iv, PFNGLWINDOWPOS3IVARBPROC, ret);
      SAFE_GET_PROC( glWindowPos3sv, PFNGLWINDOWPOS3SVARBPROC, ret);
      SAFE_GET_PROC( glWindowPos3fv, PFNGLWINDOWPOS3FVARBPROC, ret);
      SAFE_GET_PROC( glWindowPos3dv, PFNGLWINDOWPOS3DVARBPROC, ret);
       
      /* blend Func separate */
      SAFE_GET_PROC( glBlendFuncSeparate, PFNGLBLENDFUNCSEPARATEEXTPROC, ret);

      /* multi draw arrays */
      SAFE_GET_PROC( glMultiDrawArraysEXT, PFNGLMULTIDRAWARRAYSEXTPROC, ret);
      SAFE_GET_PROC( glMultiDrawElements, PFNGLMULTIDRAWELEMENTSEXTPROC, ret);
      
      return SetupGL1_3() && ret;
   }
   
   return FALSE;
}

/* Initialize standard WGL extensions */
int SetupWGLExtensions()
{
   static char wgl[] = "WGL_ARB_extensions_string WGL_ARB_pbuffer WGL_ARB_render_texture WGL_ARB_make_current_read "
      "WGL_ARB_pixel_format WGL_EXT_swap_control";
   
   return SetupExtensionsFromString(wgl);
}

int SetupARBExtensions()
{
   static char arb[] = "GL_ARB_multitexture GL_ARB_transpose_matrix GL_ARB_multisample GL_ARB_texture_env_add "
      "GL_ARB_texture_cube_map GL_ARB_texture_compression GL_ARB_texture_border_clamp GL_ARB_point_parameters "
      "GL_ARB_vertex_blend GL_ARB_texture_env_combine GL_ARB_texture_env_crossbar GL_ARB_texture_env_dot3 "
      "GL_ARB_texture_mirrored_repeat GL_ARB_depth_texture GL_ARB_shadow GL_ARB_shadow_ambient "
      "GL_ARB_window_pos GL_ARB_vertex_program GL_ARB_fragment_program";

   return SetupExtensionsFromString(arb);
}

int SetupEXTExtensions()
{
   static char ext[] = "GL_EXT_vertex_array GL_EXT_compiled_vertex_array GL_EXT_texture_object GL_EXT_fog_coord "
      "GL_EXT_secondary_color GL_EXT_draw_range_elements GL_EXT_texture3D GL_EXT_point_parameters "
      "GL_EXT_vertex_shader GL_EXT_blend_minmax GL_EXT_blend_func_subtract GL_EXT_blend_color GL_EXT_texture_rectangle";
   
   return SetupExtensionsFromString(ext);
}

int SetupATIExtensions()
{
   static char ati[] = "GL_ATI_vertex_streams GL_ATI_envmap_bumpmap GL_ATI_vertex_array_object "
      "GL_ATI_element_array GL_ATI_fragment_shader GL_ATI_separate_stencil GL_ATI_draw_buffers "
      "GL_ATI_texture_mirror_once GL_ATI_texture_float GL_ATI_texture_env_combine3 GL_ATI_vertex_attrib_array_object "
      "GL_ATI_pn_triangles";
   
   return SetupExtensionsFromString(ati);
}

/* Initialize GL2 extension entrypoints */
int SetupGL2Extensions()
{
   static char gl2[] = "GL_GL2_shader_objects GL_GL2_vertex_shader GL_GL2_fragment_shader";

   return SetupExtensionsFromString(gl2);
}

#undef SAFE_GET_PROC